sarf.color=true;
sarf.data = new Array(12);
sarf.log='';
sarf.merge3c=function (C1, C2, C3) {
      var ii = C1;
      ii = C2 <<  8 |(ii & 0xFFFF00FF);
      ii = C3 << 16 |(ii & 0xFF00FFFF); 
      return ii; 
}

/* get the octet from int |3|2|1|*/
sarf.get_octet3=function (int3, num) {
    if (num == 1) {return (int3      ) & 0x000007FF;}
    if (num == 2) {return (int3 >> 11) & 0x000007FF;}
    if (num == 3) {return (int3 >> 22) & 0x000003FF;}
    return 0;
}

sarf.arabenglish=function (c) {
	var n = c.charCodeAt();
    if ( n==1576 ) { return 'b' ; } 
    if ( n==1578 ) { return 't' ; } 
    if ( n==1579 ) { return 'J' ; } 
    if ( n==1580 ) { return 'j' ; } 
    if ( n==1581 ) { return 'H' ; } 
    if ( n==1582 ) { return 'K' ; } 
    if ( n==1583 ) { return 'd' ; } 
    if ( n==1584 ) { return 'z' ; } 
    if ( n==1585 ) { return 'r' ; } 
    if ( n==1586 ) { return 'Z' ; } 
    if ( n==1587 ) { return 's' ; } 
    if ( n==1588 ) { return 'C' ; } 
    if ( n==1589 ) { return 'S' ; } 
    if ( n==1590 ) { return 'D' ; } 
    if ( n==1591 ) { return 'T' ; } 
    if ( n==1592 ) { return 'P' ; } 
    if ( n==1593 ) { return 'g' ; } 
    if ( n==1594 ) { return 'G' ; } 
    if ( n==1601 ) { return 'f' ; } 
    if ( n==1602 ) { return 'q' ; } 
    if ( n==1603 ) { return 'k' ; } 
    if ( n==1604 ) { return 'l' ; } 
    if ( n==1605 ) { return 'm' ; } 
    if ( n==1606 ) { return 'n' ; } 
    if ( n==1607 ) { return 'h' ; } 
    if ( n==1608 ) { return 'w' ; } 
    if ( n==1609 ) { return 'u' ; } 
    if ( n==1610 ) { return 'y' ; } 
    if ( n==1569 ) { return '-' ; } 
    if ( n==1570 ) { return '~' ; } 
    if ( n==1571 ) { return 'A' ; } 
    if ( n==1572 ) { return 'o' ; } 
    if ( n==1573 ) { return 'i' ; } 
    if ( n==1574 ) { return 'Y' ; } 
    if ( n==1575 ) { return 'a' ; } 
    if ( n==1577 ) { return 'p' ; } 
    if ( n==1614 ) { return 'F' ; } 
    if ( n==1615 ) { return 'O' ; } 
    if ( n==1616 ) { return 'I' ; } 
    if ( n==1617 ) { return 'c' ; } 
    if ( n==1618 ) { return 'e' ; } 	
	return '\0';
}

sarf.get_mz_branch=function (L, c1, c2, c3, c4, c5, c6) {
  // console.log(L, c1, c2, c3, c4, c5, c6);  
	if (L == 0) {return 0; }
    if (L <= 3) { return 1; }
	if (L == 4) {
		if ( c3 == 'c' ) {return 20; }
		if ( c2 == 'a' || c2 == 'a' ) {return 21; }
	    
		if ( c1 == 'A' && c2 == 'A'  ) {
			if ( c4 == 'c') {return 2121}
			if (c3=='j'&&c4=='r') {return 2122; }
			if (c3=='j'&&c4=='m') {return 2122; }
			if (c3=='K'&&c4=='z') {return 2122; }
			if (c3=='r'&&c4=='b') {return 2122; }
			if (c3=='m'&&c4=='r') {return 2122; }
			if (c3=='m'&&c4=='n') {return 2122; }
			if (c3=='l'&&c4=='f') {return 2122; }
			if (c3=='n'&&c4=='s') {return 2122; }
			if (c3=='s'&&c4=='d') {return 2122; }
			if (c3=='d'&&c4=='b') { return 212; } 
            if (c3=='H'&&c4=='n') { return 212; }
            if (c3=='w'&&c4=='b') { return 212; }
            if (c3=='r'&&c4=='f') { return 212; }	
            if (c3=='r'&&c4=='n') { return 212; }
            if (c3=='Z'&&c4=='r') { return 212; }
            if (c3=='k'&&c4=='r') { return 212; }
            if (c3=='k'&&c4=='l') { return 212; }
            if (c3=='l'&&c4=='t') { return 212; }
            if (c3=='l'&&c4=='s') { return 212; }
            if (c3=='y'&&c4=='d') { return 212; }
            if (c3=='y'&&c4=='s') { return 212; }
            if (c3=='l'&&c4=='m') { return 212; }
			if (c3=='b'&&c4=='u') { return 2170;}
            if (c3=='l'&&c4=='u') { return 2170;}
            if (c3=='Z'&&c4=='u') { return 2170;}
            if (c3=='r'&&c4=='u') { return 2170;}
            if (c3=='n'&&c4=='u') { return 2170;}
            if (c3=='d'&&c4=='u') { return 2170;}
            if (c3=='z'&&c4=='u') { return 2170;}
            if (c3=='s'&&c4=='u') { return 2171;}	
            if (c3=='J'&&c4=='u') { return 2171;}
            if (c3=='w'&&c4=='u') { return 2171;}			
			if (c3=='t'&&c4=='u')  {return 7071;}
            if (c3=='K'&&c4=='u')  {return 7071;}
		    if ( c4 == 'u'  ) {return 7071; }
			return 222;
		}

		if ( c1 == 'A' ) {return 22; }
		if ( c1 != 'a' || c1 != 'A') {return 31; }
    }	
	if (L == 5) {
		if ( c1 == 'a' && c2 == 's' && c3 == 'T' && c4 == 'a') {return 2862; }
	    if ( c1 == 'a' && c2 == 'n' && c3 == 'D' && c5 == 'c') {return 27; }
		if ( c1 == 'a' && c2 == 'S' && c3 == 'T' && c5 == 'c') {return 27; }	
	    if ( c1 == 't' && c4 == 'c' ) {return 23; }
		if ( c1 == 't' && c3 == 'A' && (c2 == 'r' || c2 == 'l')) {return 41; }
	    if ( c1 == 't' && (c3 == 'A' || c3 == 'a')) {return 24; }
        if ( c1 == 'a' && (c3 == 'T' || c3 == 'c' || c3 == 'd') && c2 == 'n' ) {return 25; }	
		if ( c1 == 'a' && c2 == 'm' && c3 == 'c' ) {return 25; }	   
		if ( c1 == 'a' && (c3 == 'T' || c3 == 'c' || c3 == 'd' || c3 == 't')) {return 26; }		
		if ( c1 == 'a' && (c2 == 'm' || c2 == 'n')) {return 25; }
		if ( c1 == 'a' && (c5 == 'c' || c5 == 'u')) {return 27; }
		if ( c1 == 't' ) {return 41; }
	}
	if (L == 6) {
	    if ( c1 == 'a' && (c2 == 'd' || c2 == 't') && c3 == 'c' && c4 == 'a') {return 24; }
		if ( c1 == 'a' && c2 == 's' && c3 == 't') {return 28; }
		if ( c1 == 'a' && c5 == 'c' && c4 == 'w'  ) {return 2901; }
		if ( c1 == 'a' && c4 == 'a' && c6 == 'c'  ) {return 2902; }
		if ( c1 == 'a' && (c4 == 'a' || c4 == 'w')) {return 2900; }		
		if ( c1 == 'a' && c6 == 'c' ) {return 43; }
		if ( c1 == 'a'  ) {return 42; }
	}	
	return 0;
}

sarf.get_bit=function (n, k) {
    return (n & ( 1 << k )) >> k;
}

sarf.get3mz=function (c1,c2,c3) {
	var key = sarf.merge3c (c1.charCodeAt(0), c2.charCodeAt(0), c3.charCodeAt(0));
	m1=1; m2=1;m3=1;m4=1;m5=1;m6=1;
	mz1=0; mz2=0;mz3=0;mz4=0;mz5=0;mz6=0;
	if ( typeof(sarf.mroot3[key]) != 'undefined' ) {
	    mz = sarf.mroot3[key];
	    m6 = sarf.get_bit(mz, 5);
	    m5 = sarf.get_bit(mz, 4);
	    m4 = sarf.get_bit(mz, 3);
	    m3 = sarf.get_bit(mz, 2);
	    m2 = sarf.get_bit(mz, 1);
	    m1 = sarf.get_bit(mz, 0);
	}
	
	if (m1 == 1) {
	   if      (c1 == 'k' && c2 == 'a' && c3 == 'n') { mz1 = 1161; }
	   else if (c1 == 'A' && c3 == 'c')              { mz1 = 1111; }
	   else if (c3 == 'c')                           { mz1 = 111;  }
 	   else if (c2 == 'A' && c3 == 'w')              { mz1 = 1171; }
	   else if (c2 == 'A' && c3 == 'u')              { mz1 = 1173; }
	   else if (c1 == 'A' && c2 == 'A')              { mz1 = 1162; }
	   else if (c1 == 'A' && c3 == 'a')              { mz1 = 1172; }
	   else if (c1 == 'w')                           { mz1 = 115;  }
	   else if (c3 == 'a')                           { mz1 = 117;  }
	   else if (c1 == 'A')                           { mz1 = 112;  }
	   else if (c3 == 'A')                           { mz1 = 114;  }
       else if (c3 == '-')                           { mz1 = 1163; }
	   else if (c2 == 'a')                           { mz1 = 116;  }
	   else                                          { mz1 = 110;  }
	}
	if (m2 == 1) {
	  if     (c1 == 'A' && c3 == 'c')               { mz2 = 1211; }
	  else if (c3 == 'c')                           { mz2 = 121;  }
	  else if (c3 == '-')                           { mz2 = 1261; }
	  else if (c1 == 'w' && c2 == 'A' && c3 == 'u') { mz2 = 1281; }
	  else if (c1 == 'w' && c3 == 'u')              { mz2 = 128;  }
	  else if (c1 == 'A' && c2 == 'w' && c3 == 'u') { mz2 = 1291; }
	  else if (c3 == 'u' && c2 == 'w')              { mz2 = 129;  }
	  else if (c1 == 'A' && c3 == 'u')              { mz2 = 1271; }
      else if (c1 == 'w' && c2 == 'A')              { mz2 = 1252; }
	  else if (c1 == 'A' && c2 == 'A')              { mz2 = 1262; }
	  else if (c2 == 'A')                           { mz2 = 123;  }
	  else if (c3 == 'u')                           { mz2 = 127;  }
	  else if (c2 == 'a')                           { mz2 = 126;  }
	  else if (c1 == 'A')                           { mz2 = 122;  }
	  else if (c1 == 'w')                           { mz2 = 125;  }
	  else if (c1 == 'y')                           { mz2 = 1251; }
	  else                                          { mz2 = 120;  }
	}	
	if (m3 == 1) {
		if       (c1 == 'A' && c3 == 'c')               { mz3 = 1211; }
		else if   (c2 == 'A' && c3 == 'u' && c1 == 'r') { mz3 = 1371; }
	    else if   (c2 == 'A' && c3 == 'u')              { mz3 = 1372; }
	    else if   (c1 == 'w' && c3 == 'A')              { mz3 = 1351; }
	    else if   (c2 == 'a' && c3 == '-')              { mz3 = 1361; }
	    else if   (c3 == 'c')                           { mz3 = 131;  }
	    else if   (c2 == 'a')                           { mz3 = 136;  }
	    else if   (c3 == 'u')                           { mz3 = 137;  }
		else if   (c3 == 'A')                           { mz3 = 134;  }
		else if   (c2 == 'A')                           { mz3 = 133;  }
		else if   (c1 == 'A')                           { mz3 = 132;  }
		else if   (c1 == 'w')                           { mz3 = 135;  }
		else                                            { mz3 = 130;  }
	}	
	if (m4 == 1) {
	    if        (c3 == 'c')                            { mz4 = 141;  }
		else if   (c2 == 'y' && c3 == 'o')               { mz4 = 146;  }
		else if   (c3 == 'o')                            { mz4 = 144;  }
		else if   (c2 == 'o')                            { mz4 = 143;  }
		else if   (c1 == 'A')                            { mz4 = 142;  }
		else if   (c1 == 'w')                            { mz4 = 1451; }
		else if   (c3 == 'w')                            { mz4 = 147;  }
		else if   (c1 == 'y')                            { mz4 = 145;  }
		else                                             { mz4 = 140;  }
	}		
	if (m5 == 1) {
	   if        (c3 == 'c' && c1 == 'A')               { mz5 = 1511; }
	   else if   (c3 == 'c')                            { mz5 = 151;  }
	   else if   (c2 == 'w' && c3 == 'y')               { mz5 = 159;  }
	   else if   (c1 == 'A' && c3 == 'y')               { mz5 = 1571; }
	   else if   (c1 == 'A' && c2 == 'w')               { mz5 = 1562; }
	   else if   (c1 == 'w' && c3 == 'y')               { mz5 = 158;  }
	   else if   (c1 == 'w' && c3 == 'Y')               { mz5 = 1552; }
	   else if   (c2 == 'a' && c3 == '-')               { mz5 = 1561; }
	   else if   (c2 == 'y' && c3 == 'y')               { mz5 = 159;  }
	   else if   (c1 == 'w')                            { mz5 = 1551; }
	   else if   (c3 == 'y')                            { mz5 = 157;  }
	   else if   (c3 == 'Y')                            { mz5 = 154;  }
	   else if   (c2 == 'Y')                            { mz5 = 153;  }
	   else if   (c2 == 'a')                            { mz5 = 156;  }
	   else if   (c1 == 'y')                            { mz5 = 155;  }
	   else if   (c1 == 'A')                            { mz5 = 152;  }
	   else                                             { mz5 = 150;  }
	}
	if (m6 == 1) {
	    if       (c1 == 'w' && c3 == 'y' &&  c2 == 'r') { mz6 = 1681; }
        else if  (c1 == 'w' && c3 == 'y')               { mz6 = 168;  }
	    else if  (c1 == 'w')                            { mz6 = 165;  }
        else if  (c1 == 'y' && c2 == 'Y')               { mz6 = 1652; }
        else if  (c1 == 'y')                            { mz6 = 1651; }
	    else                                            { mz6 = 160;  }
	}
   res=new Object;
   var i=0;
   if(mz1>0) {res[i++]=mz1;}; if(mz2>0) {res[i++]=mz2;}; if(mz3>0) {res[i++]=mz3;}
   if(mz4>0) {res[i++]=mz4;}; if(mz5>0) {res[i++]=mz5;}; if(mz6>0) {res[i++]=mz6;}
   return res;
}


sarf.getmz=function (L, c1, c2, c3, c4, c5, c6) {
    
	var mz = sarf.get_mz_branch (L, c1, c2, c3, c4, c5, c6);

    if (mz == 1 ) { return sarf.get3mz(c1, c2, c3); }
	mz2=0;
    if ( mz == 20) {
        if      (c2 == 'y' && c4 == 'a') { mz1 = 2091; }
        else if (c2 == 'A' && c4 == 'u') { mz1 = 2072; }
		else if (c1 == 'A' && c4 == 'u') { mz1 = 2071; }
        else if (c4 == 'u')              { mz1 = 207;  }
        else if (c1 == 'A')              { mz1 = 202;  }
		else if (c2 == 'A')              { mz1 = 203;  }
		else if (c4 == 'A')              { mz1 = 204;  }
		else                             { mz1 = 200;  }
   } else if ( mz == 21) {
        if      (c3 == '-' && c4 == 'u')              { mz1 = 2172; }
        else if (c1 == 'A' && c2 == 'A' && c4 == 'u') { mz1 = 2171; }
        else if (c3 == 'y' && c4 == 'a')              { mz1 = 2173; }
	    else if (c4 == 'A')                           { mz1 = 214;  }
        else if (c4 == 'a' || c4 == 'u')              { mz1 = 217;  }
	    else if (c3 == '-')                           { mz1 = 213;  }
	    else if (c1 == 'A' && c2 == 'A')              { mz1 = 212;  }
	    else if (c4 == 'c')                           { mz1 = 211;  }
        else                                          { mz1 = 210;  }
    } else if ( mz == 222) {
 	        mz1 = 222; 
    } else if ( mz == 2122) {
 	        mz2 = 222; mz1 = 212; 
	} else if ( mz == 2121) {
 	        mz1 = 2121; 
	} else if ( mz == 212) {
 	        mz1 = 212; 	
	} else if ( mz == 2170) {
 	        mz1 = 2170; 		
	} else if ( mz == 2171) {
 	        mz1 = 2171; 
	} else if ( mz == 7071) {
 	        mz2 = 2170; mz1 = 2171; 		
	} else if ( mz == 22 ) {
        if (c4 == '-')                   { mz1 = 2261; }
   	    else if (c4 == 'u' && c3 == 'A') { mz1 = 2272; }
        else if (c4 == 'c')              { mz1 = 221;  }
        else if (c2 == 'y' && c4 == 'P') { mz1 = 225;  }
        else if (c2 == 'A')              { mz1 = 222;  }
	    else if (c3 == 'A')              { mz1 = 223;  }
	    else if (c4 == 'A')              { mz1 = 224;  }
	    else if (c3 == 'a')              { mz1 = 226;  }
	    else if (c4 == 'a')              { mz1 = 227;  }
	    else if (c4 == 'u')              { mz1 = 2271; }
	    else                             { mz1 = 220;  }
   } else if ( mz == 23 ) {
       if      (c2 == 'A' && c5 == 'u') { mz1 = 2371; }
	   else if (c2 == 'A')              { mz1 = 231;  }
       else if (c5 == 'u')              { mz1 = 237;  } 
	   else if (c5 == 'A')              { mz1 = 234;  }
	   else if (c3 == 'A')              { mz1 = 233;  }
	   else                             { mz1 = 230;  }
   } else if ( mz == 24 ) {
       if      (c4 == '-' && c5 == 'u')              { mz1 = 2471; } 
	   else if (c2 == 'A' && c3 == 'A' && c5 == 'u') { mz1 = 246;  }
       else if (c2 == 'A' && c5 == 'u')              { mz1 = 247;  } 
       else if (c5 == 'u')                           { mz1 = 247;  } 
	   else if (c5 == 'c')                           { mz1 = 241;  } 
	   else if (c5 == 'A')                           { mz1 = 244;  } 
	   else if (c3 == 'A')                           { mz1 = 242;  } 
	   else if (c4 == '-')                           { mz1 = 243;  } 
	  // else if (c2 == 'w' && c4 == 'y')              { mz1 = 249;  }
	   else if (c1 == 'a' && c2 == 't' && c3 == 'c') { mz1 = 2462; }
	   else if (c1 == 'a' && c2 == 'd' && c3 == 'c') { mz1 = 2441; }
       else                                          { mz1 = 240;  }
    } else if ( mz == 25 ) {
	    if      (c3 == 'c' && c5 == 'u') { mz1 = 2502; }   
        else if (c3 == 'c')              { mz1 = 2501; }
	    else if (c3 == 'A' && c4 == 'A') { mz1 = 2562; }
	    else if (c3 == 'A')              { mz1 = 252;  }
        else if (c4 == 'A' && c5 == 'u') { mz1 = 2571; }
	    else if (c5 == 'u')              { mz1 = 257;  }
	    else if (c5 == 'A')              { mz1 = 254;  }
	    else if (c4 == 'a')              { mz1 = 256;  }
        else if (c5 == 'c')              { mz1 = 251;  } 
        else                             { mz1 = 250;  }
   } else if ( mz == 26 ) {
	    if      (c5 == 'u' && c2 == 'y')                              { mz1 = 268;  }
 	    else if (c5 == 'u' && c2 == 'Y')                             { mz1 = 2612; }   
	    else if (c2 == 'Y' && c5 == 'c')                             { mz1 = 2611; } 
	    else if (c3 == 'c' && c5 == 'c')                             { mz1 = 2613; }
	    else if (c4 == 'A' && c5 == 'u')                             { mz1 = 2673; }
	    else if (c3 == 'c' && c4 == 'A')                             { mz1 = 2631; }
	    else if (c2 == 'D' && c3 == 'T' && c5 == 'c')                { mz1 = 2614; } 
	    else if (c2 == 'S' && c3 == 'T' && c4 == 'a')                { mz1 = 2662; } 
	    else if (c2 == 'S' && c3 == 'T' && c5 == 'u')                { mz1 = 2666; } 
	    else if (c2 == 'Z' && c3 == 'd' && c5 == 'u')                { mz1 = 2664; } 
	    else if (c2 == 'Z' && c3 == 'd' && c4 == 'a')                { mz1 = 2665; } 
	    else if ((c2 == 't' || c2 == 'd') && c3 == 'c' && c5 == 'u') { mz1 = 2671; }
	    else if (c5 == 'c')                                          { mz1 = 261;  } 
	    else if (c5 == '-')                                          { mz1 = 2663; }
	    else if (c5 == 'u')                                          { mz1 = 267;  }
	    else if (c4 == 'a')                                          { mz1 = 266;  }
	    else if (c5 == 'A')                                          { mz1 = 264;  }
	    else if (c4 == 'A')                                          { mz1 = 263;  }
	    else if (c2 == 'Y')                                          { mz1 = 262;  }
	    else if (c3 == 'c')                                          { mz1 = 2603; }  
	    else if ((c2 == 'S' || c2 == 'D') && c3 == 'T')              { mz1 = 2602; } 
	    else if (c2 == 'Z' && c3 == 'd')                             { mz1 = 2601; } 
	    else                                                         { mz1 = 260;  }
	 } else if ( mz == 27 ) {
	    if (c5 == 'u') { mz1 = 277; }
	    else           { mz1 = 270; }
	 } else if ( mz == 2862 ) {
		   mz1=2862; //asta3a
	 } else if ( mz == 28 ) {
	   if      (c6 == 'c' && c4 == 'A') { mz1 = 2811; }
	   else if (c6 == 'c')              { mz1 = 281;  }
	   else if (c4 == 'A' && c6 == 'u') { mz1 = 2871; }
	   else if (c6 == 'u')              { mz1 = 287;  }
	   else if (c6 == 'A')              { mz1 = 284;  }
	   else if (c6 == 'a')              { mz1 = 289;  }
	   else if (c5 == 'a' && c6 == '-') { mz1 = 2861; }
	   else if (c5 == 'a')              { mz1 = 286;  }
	   else if (c4 == 'A')              { mz1 = 282;  }
	   else if (c5 == 'A')              { mz1 = 283;  }
	   else                             { mz1 = 280;  }
	} else if ( mz == 2900 ) {
	    if (c6 == 'u') {mz1 = 29007; }
		else           {mz1 = 2900;  }
	} else if ( mz == 2901 ) {
	    if (c6 == 'u') { mz1 = 29019; }
		else           { mz1 = 2901;  }
	 } else if ( mz == 2902 ) {
	    if      (c5 == 'y') { mz1 = 29027; }
		else if (c2 == 'y') { mz1 = 29025; }
		else                { mz1 = 2902;  }
	} else if ( mz == 31 ) {
	  if      (c2 == 'A' && c4 == 'A') { mz1 = 311;  }
	  else if (c4 == 'u')              { mz1 = 317;  }
	  else if (c2 == 'A')              { mz1 = 313;  }
	  else if (c3 == 'A')              { mz1 = 314;  }
	  else if (c4 == 'A')              { mz1 = 3141; }
	  else                             { mz1 = 310;  }
	} else if ( mz == 41 ) {
	    if      (c3 == 'A' && c5 == 'A') { mz1 = 411; }
	    else if (c4 == 'A')              { mz1 = 415; }
		else if (c3 == 'A')              { mz1 = 413; }
		else if (c5 == 'u')              { mz1 = 417; }
		else if (c5 == 'A')              { mz1 = 414; }
		else                             { mz1 = 410; }
	} else if ( mz == 42 ) {
	    if      (c6 == 'u')   { mz1 = 428; }
		else if (c6 == 'A')   { mz1 = 424; }
		else if (c6 == 'A')   { mz1 = 424; }
		else if (c5 == 'c')   { mz1 = 427; }
		else                  { mz1 = 420; }
	} else if ( mz == 43 ) {
	    if            (c4 == 'A') { mz1 = 434; }
		else                      { mz1 = 430; }
	} else { mz1 =0; }		
	
	if(mz2 == 0){return s=[mz1];}	
	res=new Object;
    res[0]=mz1;
    res[1]=mz2;
    return res;
	
}

// arabic => english
sarf.jazr_w_shaddah=function (word) {
	//arablish without tashkeel
	var k=-1;
	var w = new Array(20);
	word=word.split('');
	for (i in word) {
	   cx = sarf.arabenglish(word[i]);
	   //console.log('jazr_w_shaddah cx: ',cx);
       if ( !(cx == 'F' ||  cx == 'O' || cx == 'I' || cx == 'e') ) {
            if (cx == '~') {
			    w[++k] = 'A'; w[++k]= 'A'; 
		 	}  else {
			    w[++k] = cx;
			}
	   }	   
	}
   //console.log('jazr_w_shaddah: ',w, w.length);
   var L = 0;
   for (i in w) {
	   L++;
	   //console.log('w['+i+']='+w[i],L);
   }
   
   if ( L == 3 ) {
       if ( w[0] == 'A' &&  w[1] == 'A')  { return w[0]+w[1]+w[2];}
	   if ( w[0] == '-' &&  w[1] == 'a')  { return w[0]+w[1]+w[2];}
   }
   if ( L == 4 ) {
      if ( w[0] == 'A' &&  w[1] == 'A')  { return w[0]+w[2]+w[3];}
	  if ( w[0] == 'A' &&  w[1] == 'a')  { return w[0]+w[2]+w[3];}
	  if ( w[0] == '-' &&  w[1] == 'a')  { return w[0]+w[2]+w[3];}	  
      if ( w[0] == 'A'                )  { return w[1]+w[2]+w[3];}
	  if ( w[2] == 'c'                )  { return w[0]+w[1]+w[3];}  
      if ( w[1] == 'a'                )  { return w[0]+w[2]+w[3];}	  
   }
  
   if ( L == 5 ){
      if ( w[0] == 'a' && w[1] == 's' && w[2] == 'T' && w[3] == 'a') {  return w[2]+w[3]+w[4];}
      if ( w[0] == 'a' && w[1] == 'D' && w[2] == 'T' ) {  return w[1]+w[3]+w[4];}
	  if ( w[0] == 'a' && w[1] == 'n' && w[2] == 'D' && w[4] == 'c' ) {  return w[1]+w[2]+w[3]+w[4]; }
		  
	  if ( w[0] == 'a' && w[1] == 'n' && w[4] == 'c' ) {  return w[2]+w[3]+w[3];}
      if ( w[1] == w[2]                              ) {  return w[2]+w[3]+w[4];}
	  if ( w[0] == 'a' && w[2] == 'c' && w[4] == 'c' ) {  return w[1]+w[3]+w[3];}
	  if ( w[0] == 'a' && w[2] == 't' && w[4] == 'c' ) {  return w[1]+w[3]+w[3];}
	  if ( w[0] == 'a' && w[1] == 't' && w[2] == 'c' ) {  return w[1]+w[3]+w[4];}
	  if ( w[0] == 'a' && w[1] == 'J' && w[2] == 'c' ) {  return w[1]+w[3]+w[4];}
	  if ( w[0] == 'a' && w[1] == 'd' && w[2] == 'c' ) {  return w[1]+w[3]+w[4];}
	  if ( w[0] == 'a' && w[1] == 'n' && w[2] == 't' ) {  return w[1]+w[3]+w[4];}
	  if ( w[0] == 'a' && w[1] == 'D' && w[2] == 'c' ) {  return w[1]+w[3]+w[4];}

	  if ( w[0] == 'a' && w[4] == 'c'                ) { return w[1]+w[2]+w[3]+w[3]; }
	  if ( w[0] == 'a' && w[1] == 'm' && w[2] == 'c' ) { return w[1]+w[3]+w[4];}
      if ( w[0] == 'a' && w[1] == 'Z' && w[2] == 'd' ) { return w[1]+w[3]+w[4];}  	  
	  if ( w[0] == 'a' && w[1] == 'S' && w[2] == 'T' ) { return w[1]+w[3]+w[4];}
	  if ( w[0] == 'a' && w[1] == 'T' && w[2] == 'c' ) { return w[1]+w[3]+w[4];}
      if ( w[0] == 'a' && w[2] == 't'                ) { return w[1]+w[3]+w[4];}
      if ( w[0] == 't' && w[2] == 'a'                ) { return w[1]+w[3]+w[4];}
      if ( w[0] == 't' && w[3] == 'c'                ) { return w[1]+w[2]+w[4];}
      if ( w[0] == 'a' && w[1] == 'n'                ) { return w[2]+w[3]+w[4];}
      if ( w[0] == 'a' && w[3] == 'w'  && w[4] == 'u') { return w[1]+w[2]+w[3];}
      if ( w[0] == 't'                               ) { return w[1]+w[2]+w[3]+w[4];}
	  if ( w[0] == 'a' && w[2] == 'c'                ) { return w[1]+w[3]+w[4]; }
   } 
   if ( L == 6 ) {
      if ( w[0] == 'a' && w[1] == 's'  && w[2] == 't' ) {  return w[3]+w[4]+w[5];}
      if ( w[0] == 'a' && w[3] == 'w'  && w[4] == w[2]) {  return w[1]+w[2]+w[4]+w[5];}
      if ( w[0] == 'a' && w[4] == 'c'  && w[3] == 'w' ) {  return w[1]+w[2]+w[5];}
      if ( w[0] == 'a' && w[3] == 'a'  && w[5] == 'c' ) {  return w[1]+w[2]+w[4]+w[4];}
	  if ( w[0] == 'a'           &&       w[4] == 'c' ) {  return w[1]+w[2]+w[3]+w[5];}
      if ( w[0] == 'a'           &&       w[5] == 'c' ) {  return w[1]+w[2]+w[3]+w[4]+w[4];}
	  if ( w[0] == 'a'           &&       w[5] == 'u' ) {  return w[1]+w[2]+w[3]+w[4];}
	  if ( w[0] == 'a' && w[2] == 'c'  && w[3] == 'a' ) {  return w[1]+w[4]+w[5];}
	  if ( w[0] == 'a'                                ) {  return w[1]+w[2]+w[4]+w[5];}
   }  
   var res='';
   for (i in w) {res+=w[i];}
   return res;
   
}

// arabic => english
sarf.jazrword=function (word) {
	var res = '';
	var p = sarf.jazr_w_shaddah(word);
	p = p.split('');
	for (i in p) {
	    if ( p[i] == 'c' ) { 
		    res+=old;
		} else {
		    res+=p[i];
		}
		old =p[i];
	}
    return	res;
}

sarf.ar_encode=function (code) {
	switch (code) {
	    case 'b': return 'ب';
        case 't': return 'ت';
        case 'J': return 'ث';
        case 'j': return 'ج';
        case 'H': return 'ح';
        case 'K': return 'خ';
        case 'd': return 'د';
        case 'z': return 'ذ';
        case 'r': return 'ر';
        case 'Z': return 'ز';
        case 's': return 'س';
        case 'C': return 'ش';
        case 'S': return 'ص';
        case 'D': return 'ض';
        case 'T': return 'ط';
        case 'P': return 'ظ';
        case 'g': return 'ع';
        case 'G': return 'غ';
        case 'f': return 'ف';
        case 'q': return 'ق';
        case 'k': return 'ك';
        case 'l': return 'ل';
        case 'm': return 'م';
        case 'n': return 'ن';
        case 'h': return 'ه';
        case 'w': return 'و';
        case 'u': return 'ى';
        case 'y': return 'ي';
        case '-': return 'ء';
        case '~': return 'آ';
        case 'A': return 'أ';
        case 'o': return 'ؤ';
        case 'i': return 'إ';
        case 'Y': return 'ئ';
        case 'a': return 'ا';
        case 'p': return 'ة';
        case 'F': return 'َ';
        case 'O': return 'ُ';
        case 'I': return 'ِ';
        case 'c': return 'ّ';
        case 'e': return 'ْ';
		case 'N': return 'ٍ';
		case 'M': return 'ً';
		case 'Q': return 'ٌ';
		case 'X': return '-';
		case '0': return '0';
		case '1': return '1';
		case '2': return '2';
		case '3': return '3';
		case '4': return '4';
		case '5': return '5';
		case '6': return '6';
		case '7': return '7';
		case '8': return '8';
		case '9': return '9';
		case ';': return ';';
		case ',': return ',';	
        case ' ': return ' ';
        case '.': return '.';		
        case '?': return '?';
        case ':': return ':';
        case '!': return '!';
        case '@': return '@';
        case '_': return '_';
        case '#': return '#';
        case '*': return '*';
        case '$': return '$';
        case '+': return '+';
        case '%': return '%';
	}
	return code;
}

//sarf.decode=function (str) {
//	str=str.replace('nen','nc');
//	str=str.replace('tet','tc');
//	var s='';
//	for (var i=0;i<str.length; i++) {
//	   s+=sarf.ar_encode (str[i]);
//	}
//	return s;
//}


 sarf.issep =function (code) {
	switch (code) {	 
        case '&': return true;	
        case '?': return true;
        case ':': return true;
        case '!': return true;
        case '@': return true;
        case '_': return true;
        case '#': return true;
        case '*': return true;
        case '$': return true;
        case '+': return true;
        case '%': return true;
	}
	return false;
}
 
 sarf.decode=function (str) {
 	var s='';
 	//console.log('idgham:'+str);
	
 	for (var i=0;i<str.length; i++) {
 		     // Idgam el noon wal ta2
 		    H0=str[i];
 			H1=str[i+1]||'';
 			H2=str[i+2]||'';
 			H3=str[i+3]||'';
			H4=str[i+4]||'';
			//if (H0 === ":" && (H1 === "F" || H1 === "O" || H1 === "I" || H1 === "c" || H1 === "e" || H1 === "N" || H1 === "M" || H1 === "Q")) {
			//	H0 = '';
			//}
			
 			if (( H0 == 'n' && H1 == 'e' && H2 == 'n' && H3 != 'c') || (H0 == 't' && H1 == 'e' && H2 == 't' )) {
 		         s+=sarf.ar_encode(H0);
 				 s+=( sarf.ar_encode('c') );
 				 i=i+2;
	        } else if (( H0 == 'n' &&  sarf.issep(H1) && H2 == 'e' && H3 == 'n' && H4 != 'c') || ( H0 == 't' &&  sarf.issep(H1) && H2 == 'e' && H3 == 't')) {
	        	s+=sarf.ar_encode(H0);
 	        	s+=( sarf.ar_encode('c') );
 	        	 i=i+3;
	        	
	        } else {
 			     s+=sarf.ar_encode (str[i]);
 		}
	}
    if (sarf.color===true) {
        return ArShaper.colorize_verbs(s);
    } else {
        return s;
    }
 }

 sarf.decode2=function (str) {
     var s='';
 	for (var i=0;i<str.length; i++) {
           s+=sarf.ar_encode (str[i]);
	}
        return s;
 }

 
sarf.getgroup=function (j,n) { 
    if ( (n == 5 || n == 6) && j == 0 ) {return 2;}
	if ( (n == 5 || n == 6) && j == 8 ) {return 1;}
	if ( (n == 5 || n == 6) && j == 9 ) {return 1;}
	if ( (n == 5 || n == 6) && j == 10 ) {return 2;}
	if ( (n == 5 || n == 6) && j == 11 ) {return 3;}
	if ( (n == 5 || n == 6) && j == 12 ) {return 3;}
	if (j <= 1)          { return 1; }   // ana nahno
    if (j >= 2 && j <= 6) { return 2; }   // anata anti ..
    if (j >= 7 && j <= 12) { return 3; }  // howa howi ....
	return 0;
}	

sarf.isTasrifExist=function (str) { 
    if (str == '\0' || str=='' ) {return 0;}
	return 1;
}

sarf.getMawazin=function (verb) {
	var c1=0, c2=0, c3=0, c4=0, c5=0,c6=0;
	if (verb.length<2) {return;}
    //arablish without tashkeel
	var k=-1;
	var w = new Array();
	verb=verb.split('');
	for (i in verb) {
	   cx = sarf.arabenglish(verb[i]);
       if ( !(cx == 'F' ||  cx == 'O' || cx == 'I' || cx == 'e') ) {
            if (cx == '~') {
			    w[++k] = 'A'; w[++k]= 'A'; 
		 	}  else {
			    w[++k] = cx;
			}
	   }	   
	}
    var L = w.length;
	if(L>= 1) {c1 = w[0];}
	if(L>= 2) {c2 = w[1];}
	if(L>= 3) {c3 = w[2];}
	if(L>= 4) {c4 = w[3];}
	if(L>= 5) {c5 = w[4];}	
	if(L>= 6) {c6 = w[5];}	
    //console.log('mz:'+L+' '+c1+' '+c2+' '+c3+' '+c4+' '+c5+' '+c6);	
	str=sarf.getmz (L, c1, c2, c3, c4, c5, c6);
	// console.log('mwazin:'+str);
	return sarf.getmz (L, c1, c2, c3, c4, c5, c6);
}

// tasrif verbs
sarf.header=['almaDy','mrfwg','mnSwb','mjZwm','mokd','alAmr','mokd','almaDy','mrfwg','mnSwb','mjZwm','mokd'];
sarf.damir=['Ana','nHn','AntF','AntI','Antma','Antm','Antnc','hw','hy','hma','hma','hm','hnc'];
// Initialize sarf.JADWAL1 
sarf.JADWAL1 = ['','Q','FpQ','FanI','FtFanI','OwnF','FatQ','Ma','FpM','FyenI','FtFyenI','IynF','FatN','N','FpN'];
// Initialize sarf.JADWAL2 
sarf.JADWAL2 = ['','O','FpO','Fa','FtFa','Ow','FatO','F','FpF','Fye','FtFye','Iy','FatI','I','FpI'];
// Initialize sarf.JADWAL3 
sarf.JADWAL3 = ['','O','FpO','FanI','FtFanI','OwnF','FatO','F','FpF','FyenI','FtFyenI','IynF','FatI','I','FpI'];
// Initialize sarf.JADWALA 
sarf.JADWALA = ['','hO','hFa','hOme','hOmFa','hOncF'];
// Initialize sarf.JADWALB 
sarf.JADWALB = ['','kF','kI','kOmFa','kOme','kOncF'];
// Initialize sarf.JADWALC 
sarf.JADWALC = ['','nFa','nIy'];
// verb: arabic entry
// mizen: 110 120 ... from getmz.
// display: 

sarf.tasrif=function (verb, mizen,form,display) {
	sarf.log='';
	try {
    var n, i, j;
	var grpi, cpi, index;
	var a0,a1,a2,a3,a4,a5;
	var C1=0, C2=0, C3=0, C4=0, C5=0;
    var p = sarf.jazrword(verb);
	p=p.split('');
	// console.log('p: ',p);
	var L = p.length;
	if(L>= 1) {C1 = p[0];}
	if(L>= 2) {C2 = p[1];}
	if(L>= 3) {C3 = p[2];}
	if(L>= 4) {C4 = p[3];}
	if(L>= 5) {C5 = p[4];}
	
	for (var n=0; n<= 12 ; n++) {
   	    sarf.data[n] = new Array(13);
	    for (j=0; j<= 12; j++) {
	       sarf.data[n][j]='';
	    }
    }
	
	var N=11,M=12; 
	for (n=0; n<= N ; n++) {
        for (j=0; j<= M; j++) {
			
			index = parseInt(j/3);
			cpi = sarf.MZ[mizen][n]; 	  	  
            
			grpi = sarf.CP[cpi][0];
			
			a0 = sarf.GR[sarf.get_octet3(grpi,1)][index]; a0 = sarf.get_octet3(a0,j%3+1);
			a1 = sarf.GR[sarf.get_octet3(grpi,2)][index]; a1 = sarf.get_octet3(a1,j%3+1);
			a2 = sarf.GR[sarf.get_octet3(grpi,3)][index]; a2 = sarf.get_octet3(a2,j%3+1);	   
			
			grpi = sarf.CP[cpi][1];
			a3 = sarf.GR[sarf.get_octet3(grpi,1)][index]; a3 = sarf.get_octet3(a3,j%3+1);
			a4 = sarf.GR[sarf.get_octet3(grpi,2)][index]; a4 = sarf.get_octet3(a4,j%3+1);
			a5 = sarf.GR[sarf.get_octet3(grpi,3)][index]; a5 = sarf.get_octet3(a5,j%3+1);	            
			
			//console.log('tasrif1:',a0,a1,a2,a3,a4,a5);
		if(sarf.color===true) {	
		    if (a0 > 1) { sarf.data[j][n]+=sarf.encode_ai(a0);} 
		    if (a1 > 1) { sarf.data[j][n]+="&"+C1+"?"+sarf.encode_ai(a1)+":";} 
		    if (a2 > 1) { sarf.data[j][n]+=C2+"!"+sarf.encode_ai(a2)+"@";} 
		    if (a3 > 1) { sarf.data[j][n]+=C3+"_"+sarf.encode_ai(a3)+"#";}
		    if (a4 > 1) { sarf.data[j][n]+=C4+"*"+sarf.encode_ai(a4)+"$";} 
		    if (a5 > 1) { sarf.data[j][n]+=C5+"+"+sarf.encode_ai(a5)+"%";}
        } else {
            if (a0 > 1) { sarf.data[j][n]=sarf.encode_ai(a0);}
		    if (a1 > 1) { sarf.data[j][n]+=C1+sarf.encode_ai(a1);}
		    if (a2 > 1) { sarf.data[j][n]+=C2+sarf.encode_ai(a2);}
		    if (a3 > 1) { sarf.data[j][n]+=C3+sarf.encode_ai(a3);}
		    if (a4 > 1) { sarf.data[j][n]+=C4+sarf.encode_ai(a4);}
		    if (a5 > 1) { sarf.data[j][n]+=C5+sarf.encode_ai(a5);}
        }
			//xxx = sarf.encode_ai(a0)+' '+C1+' '+sarf.encode_ai(a1)+' '+C2,sarf.encode_ai(a2)+' '+C3,sarf.encode_ai(a3)+' '+C4,sarf.encode_ai(a4)+' '+C5,sarf.encode_ai(a5);
			//console.log(sarf.decode(xxx));
			//console.log('tasrif1:',index,sarf.encode_ai(a0),C1,sarf.encode_ai(a1),C2,sarf.encode_ai(a2),C3,sarf.encode_ai(a3),C4,sarf.encode_ai(a4),C5,sarf.encode_ai(a5));
			// ######################################################################
			var str = sarf.data[j][n];
			var FORMX=0, FORMA=1, FORMB=2, FORMC=3, FORMBA=4, FORMCA=5;
			if (form > FORMX && sarf.isTasrifExist(str)) {
				if (n<=6) {
				sarf.data[j][n]='';
				
				// only ma3lom #1
				if ( form == FORMA ) {
			    	for (var cmpt = 1; cmpt <= 5; cmpt++) {
			    	    sarf.data[j][n]+=str+sarf.JADWALA[cmpt]+' ';
			    	}
	            }
                
				// only ma3lom #2
	            if ( form == FORMB ) {
			    	if ( sarf.getgroup(j,n) != 2 ) {
			    		for (var cmpt = 1; cmpt <= 5; cmpt++) {
			    		    sarf.data[j][n]+=str+sarf.JADWALB[cmpt]+' ';
			    		}
			    	}
			    }
	            if ( form == FORMC ) {
			    	if ( sarf.getgroup(j,n) != 1 ) {
			    		for (var cmpt = 1; cmpt <= 2; cmpt++) {
			    		    sarf.data[j][n]+=str+sarf.JADWALC[cmpt]+' ';
			    		}
			    	}
			    }	
	            if ( form == FORMBA ) {
			    	if ( sarf.getgroup(j,n) != 2 ) {
			    		for (var cmptb = 1; cmptb <= 5; cmptb++) {
						    for (var cmpta = 1; cmpta <= 5; cmpta++) {
			    		        sarf.data[j][n]+=str+sarf.JADWALB[cmptb]+sarf.JADWALA[cmpta]+' ';
							}
			    		}
			    	}
			    }	
	            if ( form == FORMCA ) {
			    	if ( sarf.getgroup(j,n) != 1) {
			    		for (var cmptc = 1; cmptc <= 2; cmptc++) {
						    for (var cmpta = 1; cmpta <= 5; cmpta++) {
								sarf.data[j][n]+=str+sarf.JADWALC[cmptc]+sarf.JADWALA[cmpta]+' ';
							}
			    		}
			    	}
			    }				
			    
			    // wasl
				str=sarf.data[j][n];
			    str=str.replace(/wea/g,'we');
			    str=str.replace(/wa/g,'w');
			    str=str.replace(/u/g,'a');
			    str=str.replace(/AFa/g,'~');
				sarf.data[j][n]=str;
			} else {
			    sarf.data[j][n]='';
			}
		}
		// ######################################################################	
		if ( (n == 5 || n == 6) && j == 2 && sarf.isTasrifExist(sarf.data[0][n]) ) { sarf.data[j][n]+=' '; sarf.data[j][n]+=sarf.data[0][n]; sarf.data[0][n]='';}
	    if ( n == 5 && j == 8  && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[0][3]+=' '; sarf.data[0][3]+=sarf.data[j][n]; sarf.data[j][n]='';}
	    if ( n == 5 && j == 9  && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[1][3]+=' '; sarf.data[1][3]+=sarf.data[j][n]; sarf.data[j][n]='';}
	    if ( n == 5 && j == 10 && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[2][3]+=' '; sarf.data[2][3]+=sarf.data[j][n]; sarf.data[j][n]='';}
	    if ( n == 5 && j == 11 && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[7][3]+=' '; sarf.data[7][3]+=sarf.data[j][n]; sarf.data[j][n]='';}
	    if ( n == 5 && j == 12 && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[8][3]+=' '; sarf.data[8][3]+=sarf.data[j][n]; sarf.data[j][n]='';}

	    if ( n == 10 && j == 0 && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[j][n]+=' '; sarf.data[j][n]+=sarf.data[8][6];  sarf.data[8][6]='';}
	    if ( n == 10 && j == 1 && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[j][n]+=' '; sarf.data[j][n]+=sarf.data[9][6];  sarf.data[9][6]='';}
	    if ( n == 10 && j == 2 && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[j][n]+=' '; sarf.data[j][n]+=sarf.data[10][6]; sarf.data[10][6]='';}
	    if ( n == 10 && j == 7 && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[j][n]+=' '; sarf.data[j][n]+=sarf.data[11][6]; sarf.data[11][6]='';}
	    if ( n == 10 && j == 8 && sarf.isTasrifExist(sarf.data[j][n]) ) { sarf.data[j][n]+=' '; sarf.data[j][n]+=sarf.data[12][6]; sarf.data[12][6]='';}
			
		}
    }
	if (display == 0) {
	     for (n=0; n<= N+1 ; n++) {
             for (j=0; j<= M; j++) {
	     		s= sarf.decode(sarf.data[n][j]);
	     		sarf.data[n][j]=s;
	     	}
	     }
	    return sarf.data;
	} else {
	    transpose =0;
        output=mizen+','+sarf.decode2("Dmyr")+';';
	    tmp =0;
	    if (transpose == 1) { tmp=N; N=M; M=tmp;}
	     
	    for (var jj=0;jj <=N;jj++) {
            if (transpose == 1) { output+=sarf.decode2(sarf.damir[jj])+';'; }
            else                { output+=sarf.decode2(sarf.header[jj])+';'; }
	    }
	     output+='\n';
	    for (var ii=0;ii<=M;ii++) {
	        if (transpose == 0) { output+=sarf.decode2(sarf.damir[ii])+';'; }
	        else                { output+=sarf.decode2(sarf.header[ii])+';'; }
	        for (var jj=0;jj <=N;jj++) {
	            if (transpose == 0) { output+=sarf.decode(sarf.data[ii][jj]); }
	    	    else                {  output+=sarf.decode(sarf.data[jj][ii]); }
	    	     output+=';';
	        }
	    	output+='\n';;
	    }
	    	
	    return output;
	}
	} catch (err) {
		 sarf.log+=err+"<br>"+err.stack;
	}
}





// -----------------------------------------------------
sarf.test_tasrif=function () {
   var error=0;
   for (var index in sarf.testmatrix) {
        mizen = index.split('.')[0];
		verb= index.split('.')[1];
		//console.log('verb: '+ verb+' mizen:' + mizen);
	    sarf.tasrif(verb,mizen, 0,0);
	    for (var i=0; i<=12;i++) {
			for (var j=0; j<=11;j++) {
		       a=sarf.data[i][j]; 
			   a=a.replace(/([\s]+$)/g, '');
			   b=(sarf.testmatrix[index])[j+1][i+1]; //transpose
			   b=b.replace(/([\s]+$)/g, '');
			   if (a != b) {
			      error++; 
				  console.log('sarf:['+a+'] ref:['+b+'] verb:['+ verb+'] mizen:['+ mizen+'] Error:['+error+']');
			   }
		    }
		}   
   }
    console.log('sarf test report:'+error+ ' errors');
} 
// sarf.test_tasrif();
// 
// v='اِفْعَنْلَلَ';     sarf.tasrif(v,420, 0,0);
 
