var ArShaper={}; 
// Basic algo support all mobile/win/linux but the font will be AmiriWeb to have a good display
ArShaper.unicode06 = 0;
ArShaper.colorLevel= true; // used for sarf talween
// if ArShaper.unicode06 = 1 it will be better for win/linux with zwj support

ArShaper.joinerRank = {0x0621:1, 0x0622:2, 0x0671:2, 0x0623:2, 0x0624:2, 0x0625:2, 
           0x0626:4, 0x0627:2, 0x0628:4, 0x0629:2, 0x062A:4, 0x062B:4,
           0x062C:4, 0x062D:4, 0x062E:4, 0x062F:2, 0x0630:2, 0x0631:2,
		   0x0632:2, 0x0633:4, 0x0634:4, 0x0635:4, 0x0636:4, 0x0637:4,
		   0x0638:4, 0x0639:4, 0x063A:4, 0x0640:4, 0x0641:4, 0x0642:4,
		   0x0643:4, 0x0644:4, 0x0645:4, 0x0646:4, 0x0647:4, 0x0648:2,
		   0x0649:2, 0x064A:4, 0x002D:1};
   
   
// Algo1   support
	  /* code, isolated,  final        initial, medial,  */
ArShaper.char = { 0x0621:[0xFE80,  null    ,        null,   null], /* HAMZA */
      0x0622:[0xFE81, 0xFE82    ,        null,   null], /* ALEF_MADDA */
      0x0623:[0xFE83, 0xFE84    ,        null,   null], /* ALEF_HAMZA_ABOVE */
      0x0624:[0xFE85, 0xFE86    ,        null,   null], /* WAW_HAMZA */
      0x0625:[0xFE87, 0xFE88    ,        null,   null], /* ALEF_HAMZA_BELOW */
      0x0626:[0xFE89, 0xFE8A    ,      0xFE8B, 0xFE8C], /* YEH_HAMZA */
      0x0627:[0xFE8D, 0xFE8E    ,        null,   null], /* ALEF */
      0x0628:[0xFE8F, 0xFE90    ,      0xFE91, 0xFE92], /* BEH */
      0x0629:[0xFE93, 0xFE94    ,        null,   null], /* TEH_MARBUTA */
      0x062A:[0xFE95, 0xFE96    ,      0xFE97, 0xFE98], /* TEH */
      0x062B:[0xFE99, 0xFE9A    ,      0xFE9B, 0xFE9C], /* THEH */
      0x062C:[0xFE9D, 0xFE9E    ,      0xFE9F, 0xFEA0], /* JEEM */
      0x062D:[0xFEA1, 0xFEA2    ,      0xFEA3, 0xFEA4], /* HAH */
      0x062E:[0xFEA5, 0xFEA6    ,      0xFEA7, 0xFEA8], /* KHAH */
      0x062F:[0xFEA9, 0xFEAA    ,        null,   null], /* DAL */
      0x0630:[0xFEAB, 0xFEAC    ,        null,   null], /* THAL */
      0x0631:[0xFEAD, 0xFEAE    ,        null,   null], /* REH */
      0x0632:[0xFEAF, 0xFEB0    ,        null,   null], /* ZAIN */
      0x0633:[0xFEB1, 0xFEB2    ,      0xFEB3, 0xFEB4], /* SEEN */
      0x0634:[0xFEB5, 0xFEB6    ,      0xFEB7, 0xFEB8], /* SHEEN */
      0x0635:[0xFEB9, 0xFEBA    ,      0xFEBB, 0xFEBC], /* SAD */
      0x0636:[0xFEBD, 0xFEBE    ,      0xFEBF, 0xFEC0], /* DAD */
      0x0637:[0xFEC1, 0xFEC2    ,      0xFEC3, 0xFEC4], /* TAH */
      0x0638:[0xFEC5, 0xFEC6    ,      0xFEC7, 0xFEC8], /* ZAH */
      0x0639:[0xFEC9, 0xFECA    ,      0xFECB, 0xFECC], /* AIN */
      0x063A:[0xFECD, 0xFECE    ,      0xFECF, 0xFED0], /* GHAIN */
      0x0640:[0x0640, 0x0640    ,      0x0640, 0x0640], /* TATWEEL */
      0x0641:[0xFED1, 0xFED2    ,      0xFED3, 0xFED4], /* FEH */
      0x0642:[0xFED5, 0xFED6    ,      0xFED7, 0xFED8], /* QAF */
      0x0643:[0xFED9, 0xFEDA    ,      0xFEDB, 0xFEDC], /* KAF */
      0x0644:[0xFEDD, 0xFEDE    ,      0xFEDF, 0xFEE0], /* LAM */
      0x0645:[0xFEE1, 0xFEE2    ,      0xFEE3, 0xFEE4], /* MEEM */
      0x0646:[0xFEE5, 0xFEE6    ,      0xFEE7, 0xFEE8], /* NOON */
      0x0647:[0xFEE9, 0xFEEA    ,      0xFEEB, 0xFEEC], /* HEH */
      0x0648:[0xFEED, 0xFEEE    ,        null,   null], /* WAW */
      0x0649:[0xFEEF, 0xFEF0    ,        null,   null], /* ALEF_MAKSURA */
      0x064A:[0xFEF1, 0xFEF2    ,      0xFEF3, 0xFEF4], /* YEH */
	  0x0671:[0xFB50,0xFB51,null,null],
	  0x002D:[0x002D,0x002D,0x002D,0x002D]
}
   
ArShaper.harakat=[0x064C,0x064F,0x064E,0x064B,0x0652,0x0651,0x064D,0x0650];
ArShaper.isHarka = function (c) {
	for (var i in ArShaper.harakat) {
		//console.log(c,c.charCodeAt(),ArShaper.harakat[i])
		if (c.charCodeAt()==ArShaper.harakat[i]) {return true;}
	}
	return false;
}

   
ArShaper.addConnectors = function (word, colors, num1, num2, number) { 
	var future = "";
	var fe = 0;
	var curr = "";
	var acc = "";
	var cold = "x";
	var code = 0;
	var len = word.length;
	var key = 0;
	var cout = "";
	var joiner = 0;
	var zwl="&#x200d;:&#x200d;";
	for (var i=0; i < len ; i++) {
		var code = word[i].charCodeAt();
		//console.log(code);
		curr = word[i];
		acc = "";
		if (ArShaper.joinerRank[code] != undefined) {
		    future = "";
		    fe = 0;	
		    for (var f=i+1; f < word.length; f++) {
		        fe = word[f];
				//console.log("Here:",f,fe, fe.charCodeAt(),ArShaper.joinerRank[word[f].charCodeAt()]);
		        if (ArShaper.joinerRank[word[f].charCodeAt()] != undefined) {
		    	    future=fe;
		    		break;				     	
		    	} else { acc+=fe;}			
		    }
			a3=ArShaper.joinerRank[cold.charCodeAt()]; 
			a2=ArShaper.joinerRank[curr.charCodeAt()];
			a1=ArShaper.joinerRank[future.charCodeAt()];
			
			if (a1 === undefined ) {a1=9;}
			if (a2 === undefined ) {a2=9;}
			if (a3 === undefined ) {a3=9;}

		    key=parseInt(a1+""+a2+""+a3);
			//console.log("word:",word, 'key:',key);

		    switch (key) {
			    case 144:  joiner = 4; break;					
			    case 214:  joiner = 4; break;	
		        case 224:  joiner = 4; break;
		        case 924:  joiner = 4; break;	
		        case 424:  joiner = 4; break;					
		        case 944:  joiner = 4; break;				
		        case 124:  joiner = 4; break; 
		        case 941:  joiner = 4; break; 
		        case 244:  joiner = 3; break;
		        case 444:  joiner = 3; break;	
		        case 242:  joiner = 2; break;
		        case 442:  joiner = 2; break;
		        case 249:  joiner = 2; break;
		        case 449:  joiner = 2; break;
		        case 441:  joiner = 2; break; 
		        case 241:  joiner = 2; break;                    					
		        default :  joiner = 1;
		    }
		    	
			// Ex 1:ﻍ  2:ﻏ  3:ﻐ  4:ﻎ
			//	console.log("c:",curr);
			// Algo1 zwj support: 	
            if (ArShaper.unicode06 === 1) {			
			    if (joiner == 4) {cout+="X"+curr+acc;}
			    if (joiner == 3) {cout+="X"+curr+acc+"X";}
			    if (joiner == 2) {cout+=curr+acc+"X";}
			    if (joiner == 1) {cout+=curr+acc;}
			} else {
			    if (joiner == 4) {cout+=String.fromCharCode(ArShaper.char[curr.charCodeAt()][1])+acc;}
			    if (joiner == 3) {cout+=String.fromCharCode(ArShaper.char[curr.charCodeAt()][3])+acc;}
			    if (joiner == 2) {cout+=String.fromCharCode(ArShaper.char[curr.charCodeAt()][2])+acc;}
			    if (joiner == 1) {cout+=String.fromCharCode(ArShaper.char[curr.charCodeAt()][0])+acc;}
			}
			//console.log("key:",key,":", cold , "  <- " , acc , "-" , curr , " -> " , future, ":::joiner:"+joiner);
		    cold=curr;    
		}
	}
	//console.log("word:",cout);
	
	// Algo1 zwj support: 	
	if (ArShaper.unicode06 === 1) {
	    cout=cout.replace(/:XX/g,zwl)
	    cout=cout.replace(/X/g,"")
	}
	
	// Colorize
	var out="";
	var colorIndex=0;
	var acolor = colors.split(":");
	var scout =  cout.split(":");
	var y=1;
	for (var x in scout) {
		out+= "<span id=\""+num1+"_"+num2+"_"+number+"_"+y+ "\" class=\"c_"+acolor[colorIndex++]+"\">"+scout[x]+"</span>";
		y++;
	}
    return out;
 }
 //aw (20 , 2, 1)
 
// ArShaper.addConnectors("بِ:ٱلْ:هُدَىٰ","4,100,5")


// ArShaper.addConnectors("","1")

ArShaper.rearrangeHarkat = function (word) { 
	word=word+"  "
	var s_swapH="";
	var len=word.length;
	var curr="";
	var furr1="";
	var furr2="";	
	for (var t=0; t<len-2; t++) {
		curr=word[t];
	    if(curr==='&' || curr==='?' || curr===':' || curr==='!' || curr==='@' ||  curr==='_' || curr==='#' || curr==='*' || curr==='$' || curr==='+' || curr==='%') {
			furr1=word[t+1];
		    furr2=word[t+2];
			var f1=ArShaper.isHarka(furr1);
			var f2=ArShaper.isHarka(furr2);
			if (f1&&f2) {s_swapH+=furr1+furr2+curr;t=t+2;} else if(f1) {s_swapH+=furr1+curr;t=t+1;} else {s_swapH+=curr;}
		} else {
			s_swapH+=curr;
		}
	}
	//console.log(s_swapH);
	return s_swapH;
}

 
ArShaper.reshape_and_colorize = function (word) { 
	var future = "";
	var fe = 0;
	var curr = "";
	var acc = "";
	var cold = "x";
	var code = 0;
	var len = word.length;
	var key = 0;
	var cout = "";
	var joiner = 0;
	for (var i=0; i < len ; i++) {
		var code = word[i].charCodeAt();
		//console.log(code);
		curr = word[i];
		acc = "";
		if (ArShaper.joinerRank[code] != undefined) {
		    future = "";
		    fe = 0;	
		    for (var f=i+1; f < word.length; f++) {
		        fe = word[f];
				//console.log("Here:",f,fe, fe.charCodeAt(),ArShaper.joinerRank[word[f].charCodeAt()]);
		        if (ArShaper.joinerRank[word[f].charCodeAt()] != undefined) {
		    	    future=fe;
		    		break;				     	
		    	} else { acc+=fe;}			
		    }
			a3=ArShaper.joinerRank[cold.charCodeAt()]; 
			a2=ArShaper.joinerRank[curr.charCodeAt()];
			a1=ArShaper.joinerRank[future.charCodeAt()];
			
			if (a1 === undefined ) {a1=9;}
			if (a2 === undefined ) {a2=9;}
			if (a3 === undefined ) {a3=9;}

		    key=parseInt(a1+""+a2+""+a3);
		    switch (key) {
			    case 144:  joiner = 4; break;				
			    case 214:  joiner = 4; break;	
		        case 224:  joiner = 4; break;
		        case 924:  joiner = 4; break;	
		        case 424:  joiner = 4; break;					
		        case 944:  joiner = 4; break;				
		        case 124:  joiner = 4; break; 
		        case 941:  joiner = 4; break; 
		        case 244:  joiner = 3; break;
		        case 444:  joiner = 3; break;	
		        case 242:  joiner = 2; break;
		        case 442:  joiner = 2; break;
		        case 249:  joiner = 2; break;
		        case 449:  joiner = 2; break;
		        case 441:  joiner = 2; break; 
		        case 241:  joiner = 2; break;                    					
		        default :  joiner = 1;
		    }
		    	
			// Ex 1:ﻍ  2:ﻏ  3:ﻐ  4:ﻎ

			    if (joiner == 4) {cout+=String.fromCharCode(ArShaper.char[curr.charCodeAt()][1])+acc;}
			    if (joiner == 3) {cout+=String.fromCharCode(ArShaper.char[curr.charCodeAt()][3])+acc;}
			    if (joiner == 2) {cout+=String.fromCharCode(ArShaper.char[curr.charCodeAt()][2])+acc;}
			    if (joiner == 1) {cout+=String.fromCharCode(ArShaper.char[curr.charCodeAt()][0])+acc;}

			//console.log("key:",key,":", cold , "  <- " , acc , "-" , curr , " -> " , future, ":::joiner:"+joiner);
		    cold=curr;    
		} else {
			if (i===0) {cout=curr;}
		}
	}
	//console.log("word:",cout);


	// Colorize
	
	if (ArShaper.colorLevel===true) {
		cout=ArShaper.rearrangeHarkat(cout);
	}
	
	len=cout.length;	
	var aout={"a0":"","a1":"","a2":"","a3":"","a4":"","a5":"","a6":"","c1":"","c2":"","c3":"","c4":"","c5":""};
	var appendto="a0";
	for (var t=0; t<len; t++) {
	    	curr=cout[t];
			
	    	// a0 & C1 ? a1 : C2 ! a2 @ C3 _ a3 # C4 * a4 $ C5 + a5 %
	     	       if ( curr==='&') {appendto="c1";
	     	} else if ( curr==='?') {appendto="a1";
	     	} else if ( curr===':') {appendto="c2";
	     	} else if ( curr==='!') {appendto="a2";
	     	} else if ( curr==='@') {appendto="c3";
	     	} else if ( curr==='_') {appendto="a3";
	     	} else if ( curr==='#') {appendto="c4";
	     	} else if ( curr==='*') {appendto="a4";
	     	} else if ( curr==='$') {appendto="c5";
	     	} else if ( curr==='+') {appendto="a5";
	     	} else if ( curr==='%') {appendto="a6";
	     	} else { aout[appendto]+=''+curr;}
	    }		
	var vout="";
	if (aout["a0"]!=="") {vout+= "<span style='color:black'>" +aout["a0"]+"</span>"}
	if (aout["c1"]!=="") {vout+= "<span style='color:green'>" +aout["c1"]+"</span>"}
	if (aout["a1"]!=="") {vout+= "<span style='color:magenta'>" +aout["a1"]+"</span>"}
	if (aout["c2"]!=="") {vout+= "<span style='color:blue'>" +aout["c2"]+"</span>"}
	if (aout["a2"]!=="") {vout+= "<span style='color:#DAA520'>" +aout["a2"]+"</span>"}
	if (aout["c3"]!=="") {vout+= "<span style='color:red'>" +aout["c3"]+"</span>"}
	if (aout["a3"]!=="") {vout+= "<span style='color:#2F4F4F'>" +aout["a3"]+"</span>"}
	if (aout["c4"]!=="") {vout+= "<span style='color:#AD2323'>" +aout["c4"]+"</span>"}
	if (aout["a4"]!=="") {vout+= "<span style='color:#548DD4'>" +aout["a4"]+"</span>"}
	if (aout["c5"]!=="") {vout+= "<span style='color:#5C7085'>" +aout["c5"]+"</span>"}
	if (aout["a5"]!=="") {vout+= "<span style='color:#1C1B1D'>" +aout["a5"]+"</span>"}
	if (aout["a6"]!=="") {vout+= "<span style='color:#00BFFF'>" +aout["a6"]+"</span>"}
    return vout;
 }


 		
 
ArShaper.colorize_verbs = function (text) { 
    var sscout =  text.split(" ");
	var out="";
	for (var y in sscout) {
		out+=ArShaper.reshape_and_colorize(sscout[y])+" ";
	}	
	return out;
}