var version=7;
var almaredlib={};
almaredlib.app="nasr";
almaredlib.includesarf=0;
//almaredlib.app="malki";
almaredlib.sarf={};
almaredlib.objectStyleSettings={"version":version,"Lang":"AR","colorSarf1":false,"colorSarf2":true,"colorSarf3":false,"current":"noto","amiri":{"font-family":"AmiriWeb", "font-size":"20"},"tahoma":{"font-family":"Tahoma, \'Times New Roman\', sans-serif", "font-size":"15"},"noto":{"font-family":"NotoNaskhArabic", "font-size":"20"} };
almaredlib.sarf.form="";
almaredlib.sarf.type="F0";
almaredlib.dir="RTL";
almaredlib.subjetshare = {};
almaredlib.datahelp1 = {};
almaredlib.datahelp2 = {};
almaredlib.datahelp3 = {};



almaredlib.subjetshare["AR"]="المارد تصريف أفعال قرآن كريم"; 
almaredlib.subjetshare["EN"]="Almared "+version+" Arabic verb conjugation/Quran Searcher/Analyser"; 
almaredlib.datahelp1["EN"]="<tbody><tr><th>Help page</th></tr><tr><td style=\"float: left;\" align=\"left\"> <div style=\"float: left;\" align=\"left\" dir=\"ltr\">Almared app is a series of Arab automated programs that serve the Arabic language. <br>- Genie-Nasr: is the sarf morphological engine, the label came to honor who helped/ing the arab. <br>- Genie-Maliki: Is a Quranic search engine, the label came to honor the Quranic Faqih Hassan bin Farhan al-Maliki.  <br>To enter conjugations please use the past tense and please put the shadda and the hamza if needed example: <br>- simple verbs: ضرب كتب هرب هاجر <br>- Shadda sensitive  vebs: شدّ فرّ فعّل  <br>- Hamza sensitive verbs: أجّل أرفق أمر سأل  <br>- Alef sensitive verbs: استأصل استمع انهزم <br>- Madda sensetive verbs: آضّ آنس آخى  <br><br> Hamza is also necessary because it's a root letter of some verbs. <br><br> For the Entry word/s please write in arabic. it's an arabic apps. <br><br>  The program will facilitate the Quranic search. Often we want to search for an aya and only we know one or more word of it, the app  will help you to find tha aya/t with 2 methods: ordred words or by random words. Why you need the random serach?  <br>- If you have in your mind that god created the worlds in some days and you need to fetch the ayats, in this case you can put in the search bar some unordered words like:الله خلق يوم  <br> Put in mind the arabic quran was written before the new orthographe rules, this means hamza rule and other rules will be different, also you can find some merged words like: O-Mousa Ya-bna-OM  <br>The shaping rules in quran called Uthmani-Script. where as the new modern typing called Imla'i. In this app we offer 2 shaping display, Uthmani-Script and Imla'i-Script, Imla'i will help the beginer and learrner. <br>You can switch between the glyph shaping methods. the grammar express will show you the words decomposition with color.     <br>You can express words by clicking on the words. <br>We have added the text coloring property of words for an education goal. <br>Coloring the splitted arabic words in the programming isn't easy we developed some algorithms to bypass the technical limitations. <br>We think that we are the first to propose such functionality in text format. <br> <br>Some tips: <br>- To express the ayats please touch the aya first [to select it], and touch the word in second phase, this will display the grammar decomposition. <br>- The grammar row will give you many important elements like the root of verb, the sarf form and other important data. <br>- To locate the highlighted aya in the chapiter, please click on the red dashed box inside the aya row. <br>------------------<br> Note: This the first version with English, please help to correct this page [Written by our poor english].</div></td></tr></tbody></table>";
almaredlib.datahelp2["EN"]="";
almaredlib.datahelp3["EN"]="";

almaredlib.datahelp1["AR"]="<tbody><tr><th> عن البرنامج  </th></tr><tr><td>تطبيقة مجّانية ثمنها فقط ٥ نجوم إذا أعجبتك، وإن لم تعجبك فأرسل لنا بريد إلكتروني وقل لنا ما هي التحسينات التي تريدها، وهكذا تُساهم ببناء البرنامج. لا تنسى تقييم التطبيقة بخمسة نجوم، فهذا هو الثمن الوحيد الذي نطلبه منك.</td><tr><td dir='rtl'>Please vote 5 stars if you like this powerfull and free and offline and no-adds/spam app. Or please send us an email with your suggetions and be a positive contributor.</td></tr><tr><td><font color='red'>الماردالعربي </font> هو سلسلة من البرامج العربية الآلية التي تخدم اللغة العربية. <br><font color='red'>المارد نصر عرب </font> هو مُحرّك التوليد الصرفي وهو من سلسلة المارد العربي، التسمية أتت لتكريم <font color='blue'> من قضى عمره في خدمة العرب.</font> <br><font color='red'>المارد المالكي</font> هو محرّك البحث القرآني وهو من سلسلة المارد العربي، التسمية أتت لتكريم <font color='blue'> الفقيه القرآني حسن بن فرحان المالكي.</font></td></tr>";
almaredlib.datahelp2["AR"]="<tr><td>لتصريف الأفعال أَدْخِلْ فعل في صيغة الماضي للضمير هو ك: رأى شدّ استنزف وكّل <br> الشدّة ضرورية للأفعال التي فيها شدّة. <br> الهمزة ضرورية أيضا لأنّها من الحروف الأساسية. مثلا أَدْخِلْ: أكل مع همزة فوق الألف، ومثلا: استدرك من دون همزة.</td></tr>";
almaredlib.datahelp3["AR"]="</tr><tr><td>هو برنامج لتسهيل البحث القرآني. غالبا ما نريد البحث عن آية ونعلم فقط كلمة أو أكثر منها، لذا فهذا البرنامج سيساعدك للبحث عنها بطريقة سريعة وسهلة، مثلا:<br>ابحث عن:<span style='color:red'> أرض خلق يوم </span><br>فإنّك ستحصل على الأية:<br> <span style='color:red'>    قُلْ أَئِنَّكُمْ لَتَكْفُرُونَ بِٱلَّذِى خَلَقَ ٱلْأَرْضَ فِى يَوْمَيْنِ وَتَجْعَلُونَ لَهُۥٓ أَندَادًا ذَٰلِكَ رَبُّ ٱلْعَٰلَمِينَ ﴿٩﴾ فصّلت-٤١</span></td></tr><tr><td>يمكنك إعراب الكلمات من خلال الضغط على الكلمات.</td></tr><tr><td>زدنا خاصية التلوين النصّي للكلمات حسب الإعراب لهدف تعليمي، وهذا هو الأوّل من نوعه في برامج القرآن الكريم. يوجد برامج تلوّن القرآن الكريم حسب الإعراب ولكنّك بحاجة لإنترنت لزيارتها، وهي تتعامل مع الكلمات بشكل صور وليس نصّ، وهذا ما يصعّب جعلها في التطبيقات، لأن حجم نسخة القرآن الكريم ستتعدّى ال٢ جيغابايت. أمّا ما قمنا به فهو تلوين نسخة إملائية وأخرى عثمانية وكلّ هذا لا يتجاوز ال٣ميغابايت مع كل خصائص البرنامج: <span style='color: rgb(105, 222, 236);'>ﺃَ</span><span style='color: rgb(92, 112, 133);'>ﻭَ</span><span style='color: rgb(0, 191, 255);'>ﻟَﻢْ</span> <span style='color: rgb(28, 27, 29);'>ﻳَﺮَ</span><span style='color: rgb(255, 0, 0);'>ﻭْﺍ</span> <span style='color: rgb(0, 139, 139);'>ﺃَﻥَّ</span> <span style='color: rgb(128, 128, 0);'>ﺍﻟﻠَّﻪَ</span> <span style='color: rgb(115, 47, 1);'>ﺍﻟَّﺬِﻱ</span> <span style='color: rgb(28, 27, 29);'>ﺧَﻠَﻖَ</span> <span style='color: rgb(0, 0, 255);'>ﺍﻟ</span><span style='color: rgb(128, 128, 0);'>ﺴَّﻤَﺎﻭَﺍﺕِ</span> <span style='color: rgb(255, 140, 0);'>ﻭَ</span><span style='color: rgb(0, 0, 255);'>ﺍﻟْ</span><span style='color: rgb(128, 128, 0);'>ﺄَﺭْﺽَ</span><span style='color: rgb(128, 128, 0);'>ﻗَﺎﺩِﺭٌ</span> <span style='color: rgb(0, 128, 0);'>ﻋَﻠَﻰٰ</span> <span style='color: rgb(218, 165, 32);'>ﺃَﻥْ</span> <span style='color: rgb(28, 27, 29);'>ﻳَﺨْﻠُﻖَ</span> <span style='color: rgb(128, 128, 0);'>ﻣِﺜْﻠَ</span><span style='color: rgb(255, 0, 0);'>ﻬُﻢْ</span> <span style='color: rgb(255, 140, 0);'>ﻭَ</span><span style='color: rgb(28, 27, 29);'>ﺟَﻌَﻞَ</span> <span style='color: rgb(0, 128, 0);'>ﻟَ</span><span style='color: rgb(255, 0, 0);'>ﻬُﻢْ</span> <span style='color: rgb(128, 128, 0);'>ﺃَﺟَﻠًﺎ</span> <span style='color: rgb(0, 191, 255);'>ﻟَﺎ</span><span style='color: rgb(128, 128, 0);'>ﺭَﻳْﺐَ</span> <span style='color: rgb(0, 128, 0);'>ﻓِﻴ</span><span style='color: rgb(255, 0, 0);'>ﻪِ</span> <span style='color: rgb(47, 79, 79);'>ﻓَ</span><span style='color: rgb(28, 27, 29);'>ﺄَﺑَﻰ</span> <span style='color: rgb(0, 0, 255);'>ﺍﻟ</span><span style='color: rgb(128, 128, 0);'>ﻈَّﺎﻟِﻤُﻮﻥَ</span> <span style='color: rgb(245, 80, 32);'>ﺇِﻟَّﺎ</span> <span style='color: rgb(128, 128, 0);'>ﻛُﻔُﻮﺭًﺍ</span> </td></tr><tr><td>يمكنك الذهاب إلى باقي السورة من خلال الضغط على اسم السورة.</td></tr><tr><td>لا داعي لوضع الحركات والشدّة في البحث. البرنامج سيحذفهم في خوارزمية البحث.</td></tr><tr><td>البرنامج لا يتعدّى ال٣ ميغابايت، وهو يعمل من دون إنترنت. فيه نسخة من القرآن الكريم بالرسم العثماني ونسخة بالرسم الإملائي وفيه بيانات الإعراب وبيانات تجذير الأسماء والأفعال وموازين كلمات القرآن. وفيه نسخة قرآن عثمانية ملوّنة حسب الإعراب وأخرى إملائية. هدفنا هو تأمين برنامج خفيف وسريع ويعمل من دون إنترنت، يسهل إستعماله في البلدان التي لا توجد فيها خدمة إنترنت مقبولة، وفي الأماكن النائية غير المغطّاة بالشبكة العنكبوتية.</td></tr><tr><td>اعتماد الرسم الإملائي لا يعجب الفقهاء لخوفهم من تحريف الكلمات، فما كان منّا إلّا أن وضعنا نسخة إملائية وأخرى عثمانية، ويمكنك الاختيار بينهما.</td></tr><tr><td>عدد كلمات القرآن تختلف بين العثماني والإملائي، لذا قمنا بوضع وصلة بين الكلمات المدموجة في الرسم العثماني، مثلا:<br>-  في الرسم العثماني: يَٰمُوسَىٰ<br>- في الرسم إملائي: يَا-مُوسَىٰ<br>- للبحث اُكتب: يا موسى<br> للبحث يجب عليك وضع الكلمات حسب الرسم الإملائي.</td></tr><tr><td>لماذا وضعنا نسخة إملائية؟ النسخة الإملائية ستسهّل قراءة القرآن الكريم، وهي سهلة للمبتدئين وللأجانب، وهي ستمكّنك من فهم القرآن بالرسم العثماني وفهم الإعراب، وهي اللغة العربية الحديثة التي تُكتب بها جميع الصحف والكتب والمناهج.</td></tr></tbody></table>"

almaredlib.translate={};
almaredlib.translate["EN"]={"Ay1":"Search","Ay2":"Quran","Mo1":"","Mo2":"Transitive","Mo3":"Transitive+","Tag13":"Exit","Tag12":"Quran uthmani script","Tag11":"Color Algorithm: <br>A-Tick: Color Algorithm for new phones.<br>B-Untick: Support old phones","Tag10":"Color quran on key press","Tag9":"Holy Quran","Tag8":"Tahoma font","Tag7":"Amiri font","Tag6":"Noto font","Tag5":"Arabic Fonts","Tag4":"Color diacritics","Tag3":"Color roots (recomended)","Tag2":"Color conjugated vebs in black","Tag1":"Color Verbs:","Perfect":"Perfect","Imperfect":"Imperfect","Imperative":"Imperative","verse":"verse","Active":"Active","Passive":"Passive","All":"Trans.","Perfect2":"Perfect","Indicative":"Indi.","Subjunctive":"Subj.","Confirmative":"Conf.","Jussive":"Juss.","Imparative1":"Imp.","Imparative2":"Conf.","form1":"form 1","form2":"form 2","form3":"form 3","form4":"form 4","form5":"form 5","form6":"form 6","Ordred":"Ordred","Random":"Random","Chapter":"Book"};
almaredlib.translate["AR"]={"Ay1":"بحث","Ay2":"القرآن","Mo1":"","Mo2":"متعدّي","Mo3":"متعدّي+","Tag13":"خروج","Tag12":"عرض القرآن بالرسم العثماني","Tag11":"خوارزمية التلوين:<br>نعم:-A- خوارزمية تلوين محسنّة للأجهزة الحديثة:<br>لا: -B- خوارزمية تعمل على كلّ الأجهزة. ","Tag10":"تلوين وإعراب القرآن عند الضغط","Tag9":"القرآن الكريم","Tag8":"الخطّ تاهوما","Tag7":"الخطّ الأميري    ","Tag6":"الخطّ نوتو","Tag5":"الخطوط العربية","Tag4":"تلوين حركات الجذور","Tag3":"تلوين تصريف الأفعال","Tag2":"تلوين تصريف الأفعال بالأسود","Tag1":"تلوين الأفعال","Perfect":"الماضي","Imperfect":"المضارع","Imperative":"الأمر","verse":"آية","Active":"معلوم","Passive":"مجهول","All":"تعدّي","Perfect2":"ماضي","Indicative":"مرفوع","Subjunctive":"منصوب","Confirmative":"مؤكّد","Jussive":"مجزوم","Imparative1":"أمر","Imparative2":"مؤكّد","form1":"الباب ١ ","form2":"الباب ٢","form3":"الباب ٣","form4":"الباب ٤","form5":"الباب ٥","form6":"الباب ٦","Ordred":"مُتسلسل","Random":"متفرّق","Chapter":"السور"};
 		

almaredlib.switchApplication = function (name) {
    if (name==="nasr") {
    	//document.getElementById("css.title").innerText="المارد نصر العرب";
		//document.getElementById("AY0").className="rotate"
		//document.getElementById("AY1").className="rotate"
		//document.getElementById("AY2").className="rotate"
        document.getElementById('buttons_tasrif').style.display='';
        almaredlib.datashare="https://play.google.com/store/apps/details?id=com.almared.tarif"; 
    	almaredlib.datahelp="<table class='Table_A' style=\"font-family:"+almaredlib.getCurrentFonFamily()+";font-size:"+almaredlib.getCurrentFontsize()+"px\">"+almaredlib.datahelp1[almaredlib.objectStyleSettings["Lang"]]+almaredlib.datahelp2[almaredlib.objectStyleSettings["Lang"]]+almaredlib.datahelp3[almaredlib.objectStyleSettings["Lang"]];
    } else {
		//document.getElementById("AY0").className="decorateT"
		//document.getElementById("AY1").className="decorateT"
		//document.getElementById("AY2").className="decorateT"
    	document.getElementById('buttons_tasrif').style.display='none';
    	document.getElementById('cssCoranButtons').style.display=''; 
		document.getElementById('sarf.header.aya').style.display=''; 
		
		
		document.getElementById("css.title").innerText="المارد المالكي";
        almaredlib.datashare="https://play.google.com/store/apps/details?id=com.almared.coran";
    	almaredlib.datahelp="<table class='Table_A' style=\"font-family:"+almaredlib.getCurrentFonFamily()+";font-size:"+almaredlib.getCurrentFontsize()+"px\">"+almaredlib.datahelp1[almaredlib.objectStyleSettings["Lang"]]+almaredlib.datahelp3[almaredlib.objectStyleSettings["Lang"]];
	}
}

// BIND Listener
document.addEventListener('DOMContentLoaded', function() {    


    document.getElementById('mared.lang').addEventListener('click', function() {  almaredlib.switchlang();});
    document.getElementById('SF0').addEventListener('click', function() {  activeFullTasrif(this.id);});
    document.getElementById('SF1').addEventListener('click', function() {  activeFullTasrif(this.id);});
    document.getElementById('SF2').addEventListener('click', function() {  activeFullTasrif(this.id);});
    document.getElementById('SF3').addEventListener('click', function() {  activeFullTasrif(this.id);});
    document.getElementById('SF4').addEventListener('click', function() {  activeFullTasrif(this.id);});
    document.getElementById('SF5').addEventListener('click', function() {  activeFullTasrif(this.id);});

	document.getElementById('F0').addEventListener('click', function() {  activeSingleTasrif(this.id);});
    document.getElementById('F1').addEventListener('click', function() {  activeSingleTasrif(this.id);});
    document.getElementById('F2').addEventListener('click', function() {  activeSingleTasrif(this.id);});
    document.getElementById('F3').addEventListener('click', function() {  activeSingleTasrif(this.id);});
    document.getElementById('F4').addEventListener('click', function() {  activeSingleTasrif(this.id);});
    document.getElementById('F5').addEventListener('click', function() {  activeSingleTasrif(this.id);});
    document.getElementById('F6').addEventListener('click', function() {  activeSingleTasrif(this.id);});	

    document.getElementById('css.aya').addEventListener('click', function() {  activeMainChoice(this.id);});
    document.getElementById('css.maaloom').addEventListener('click', function() {  activeMainChoice(this.id);});
    document.getElementById('css.majhool').addEventListener('click', function() {  activeMainChoice(this.id);});
    document.getElementById('css.allmode').addEventListener('click', function() {  activeMainChoice(this.id);});

    document.getElementById('AY0').addEventListener('click', function() {coran.serialSearch(); activeSingleSearch(this.id);});
    document.getElementById('AY1').addEventListener('click', function() {coran.randomSearch(); activeSingleSearch(this.id);});    
	document.getElementById('AY2').addEventListener('click', function() { coran.sowar("liveDisplayDivId"); activeButtons(this.id);});		
}); 

almaredlib.switchlang = function () {
	var lang =  document.getElementById('mared.lang').innerText;
	if (lang == "AR") { 
	   almaredlib.setlang("EN");
    } else {
	   almaredlib.setlang("AR");		
	}
}

almaredlib.setlang = function (lang) {

	document.getElementById('mared.lang').innerText=lang;
	almaredlib.store("objectStyleSettings","Lang",lang);
	almaredlib.objectStyleSettings["Lang"]=lang;

	lang =  document.getElementById('mared.lang').innerText;
	document.getElementById("sarf.header.mad").innerText=almaredlib.translate[lang]["Perfect"];
    document.getElementById("sarf.header.mod").innerText=almaredlib.translate[lang]["Imperfect"];
    document.getElementById("sarf.header.amr").innerText=almaredlib.translate[lang]["Imperative"];
    	
    document.getElementById("css.aya").innerText=almaredlib.translate[lang]["verse"];       
    document.getElementById("css.maaloom").innerText=almaredlib.translate[lang]["Active"];  
    document.getElementById("css.majhool").innerText=almaredlib.translate[lang]["Passive"]; 
    document.getElementById("css.allmode").innerText=almaredlib.translate[lang]["All"];
    
    document.getElementById("F0").innerHTML=almaredlib.translate[lang]["Perfect2"];
    document.getElementById("F1").innerHTML=almaredlib.translate[lang]["Indicative"];
    document.getElementById("F2").innerHTML=almaredlib.translate[lang]["Subjunctive"];
    document.getElementById("F3").innerHTML=almaredlib.translate[lang]["Jussive"];
    document.getElementById("F4").innerHTML=almaredlib.translate[lang]["Confirmative"];       
    document.getElementById("F5").innerHTML=almaredlib.translate[lang]["Imparative1"];
    document.getElementById("F6").innerHTML=almaredlib.translate[lang]["Imparative2"];
    
    document.getElementById("SF0").innerText=almaredlib.translate[lang]["form1"];
    document.getElementById("SF1").innerText=almaredlib.translate[lang]["form2"];
    document.getElementById("SF2").innerText=almaredlib.translate[lang]["form3"];
    document.getElementById("SF3").innerText=almaredlib.translate[lang]["form4"];
    document.getElementById("SF4").innerText=almaredlib.translate[lang]["form5"];		
    document.getElementById("SF5").innerText=almaredlib.translate[lang]["form6"];
    
    document.getElementById("AY0").innerText=almaredlib.translate[lang]["Ordred"];	
    document.getElementById("AY1").innerText=almaredlib.translate[lang]["Random"];	
    document.getElementById("AY2").innerText=almaredlib.translate[lang]["Chapter"];
	
	document.getElementById("sarf.header.aya1").innerText=almaredlib.translate[lang]["Ay1"];
	document.getElementById("sarf.header.aya2").innerText=almaredlib.translate[lang]["Ay2"];	
    
	document.getElementById("sarf.header.mo1").innerText=almaredlib.translate[lang]["Mo1"];	
	document.getElementById("sarf.header.mo2").innerText=almaredlib.translate[lang]["Mo2"];	
	document.getElementById("sarf.header.mo3").innerText=almaredlib.translate[lang]["Mo3"];	
   
	
	if (lang == "AR") {
    	document.getElementById("sarf.buttons").style.direction='rtl';
    	document.getElementById("sarf.buttons.top").style.direction='rtl';	
		almaredlib.dir="RTL";
    } else {
        document.getElementById("sarf.buttons").style.direction='ltr';
        document.getElementById("sarf.buttons.top").style.direction='ltr';	
		almaredlib.dir="LTR";
    }
    almaredlib.switchApplication ("nasr");
}

almaredlib.storedb = function (x, y) {
    // Check browser support
    if (typeof(Storage) !== "undefined" && localStorage != null && localStorage != undefined) {
        // Store
		localStorage.setItem(x, y);
    } else {
		almaredlib.showSettings ();
        document.getElementById("liveDisplayDivId").innerHTML+= "<br>جهازك لا يدعم حفظ الخصائص، يمكنك الإستفادة منها فقط حتى اغلاق التطبيقة.";		
    }	
}

almaredlib.restoreProfileSettings = function () {
    // Check browser support
    if (typeof(Storage) !== "undefined" && localStorage != null && localStorage != undefined) {	
        
		if (localStorage.getItem("objectStyleSettings")) {
			// get db object and load it to live object
			var currentVersion=almaredlib.objectStyleSettings["version"];
			//almaredlib.objectStyleSettings=almaredlib.getObject ("objectStyleSettings");
			var localDBobjectStyleSettings=almaredlib.getObject ("objectStyleSettings");
			var locaLdbVersion=localDBobjectStyleSettings["version"];
			if (locaLdbVersion != currentVersion) {
				// Update: store deafult object to db
				localStorage.removeItem("objectStyleSettings");
				almaredlib.storeObject ("objectStyleSettings",almaredlib.objectStyleSettings);
			} else {
				almaredlib.objectStyleSettings=almaredlib.getObject ("objectStyleSettings");
			}
		} else {
			// first install: store deafult object to db
	  	    almaredlib.storeObject ("objectStyleSettings",almaredlib.objectStyleSettings);
		}	
	    almaredlib.initFontSetup();
        sarf.color=almaredlib.objectStyleSettings["colorSarf2"]||almaredlib.objectStyleSettings["colorSarf3"];
        ArShaper.colorLevel=almaredlib.objectStyleSettings["colorSarf2"];
		
		if (localStorage.getItem("checked_rasm")==="checked"){coran.othmani=0;} 
        if (localStorage.getItem("checked_rasm")==="") {coran.othmani=1;};
		if (localStorage.getItem("checked_shape")==="checked"){ArShaper.unicode06=1;}
        if (localStorage.getItem("checked_shape")==="") {ArShaper.unicode06=0;}
		if (localStorage.getItem("checked_color")==="checked"){coran.colorize=1;}  
        if (localStorage.getItem("checked_color")==="") {coran.colorize=0;};		
		if (localStorage.getItem("checked_tasrif")==="checked") {almaredlib.includesarf=1;};		
		if (localStorage.getItem("checked_tasrif")==="") {almaredlib.includesarf=0;};	

		//console.log(coran.colorize,ArShaper.unicode06,coran.othmani);
    } else {
		document.getElementById("liveDisplayDivId").innerHTML+= "<br>جهازك لا يدعم حفظ الخصائص، يمكنك الإستفادة منها فقط حتى اغلاق التطبيقة.";
    }
    almaredlib.showSettings ();	
}

almaredlib.storeObject = function (ObjectName,Object) {
    // Check browser support
    if (typeof(Storage) !== "undefined" && localStorage != null && localStorage != undefined) {
		// Store
		localStorage.setItem(ObjectName,JSON.stringify(Object));
    } else {
		almaredlib.showSettings ();
        document.getElementById("liveDisplayDivId").innerHTML+= "<br>جهازك لا يدعم حفظ الخصائص، يمكنك الإستفادة منها فقط حتى اغلاق التطبيقة.";		
    }	
}

almaredlib.getObject = function (ObjectName) {
    // Check browser support
    if (typeof(Storage) !== "undefined" && localStorage != null && localStorage != undefined) {
		// Store
		return JSON.parse(localStorage.getItem(ObjectName));
    } else {
		almaredlib.showSettings ();
        document.getElementById("liveDisplayDivId").innerHTML+= "<br>جهازك لا يدعم حفظ الخصائص، يمكنك الإستفادة منها فقط حتى اغلاق التطبيقة.";		
    }	
}

almaredlib.store = function (Object, key, value) {
    // Check browser support
    if (typeof(Storage) !== "undefined" && localStorage != null && localStorage != undefined) {
        //  Retrieve the object from storage
        var GlobalSettings =  JSON.parse(localStorage.getItem('objectStyleSettings'));
		// Store
		if (GlobalSettings) {
			GlobalSettings[key] = value;
		} else {
			GlobalSettings = {};
			GlobalSettings[key] = value;
		}
		localStorage.setItem('objectStyleSettings',JSON.stringify(GlobalSettings));
    } else {
		almaredlib.showSettings ();
        document.getElementById("liveDisplayDivId").innerHTML+= "<br>جهازك لا يدعم حفظ الخصائص، يمكنك الإستفادة منها فقط حتى اغلاق التطبيقة.";		
    }	
}

almaredlib.getdb = function (Object, key) {
    // Check browser support
    if (typeof(Storage) !== "undefined" && localStorage != null && localStorage != undefined) {
        //  Retrieve the object from storage
        var GlobalSettings =  JSON.parse(localStorage.getItem('GlobalSettings'));
		// Store
		if (GlobalSettings) {
			return GlobalSettings[key];
		} else {
			return null;
		}
    } else {
		almaredlib.showSettings ();
        document.getElementById("liveDisplayDivId").innerHTML+= "<br>جهازك لا يدعم حفظ الخصائص، يمكنك الإستفادة منها فقط حتى اغلاق التطبيقة.";		
    }	
}

almaredlib.checked=function (flag) {
    if(flag===true) {return "checked"}
    return ""
}

almaredlib.showSettings = function () {
		var checked_color="";
		var checked_shape="";
		var checked_rasm="";
		var checked_amiri="";
		var checked_noto="";
		var checked_tahoma="";
		var w_amiri="";
		var w_tahoma=""	;
		var w_noto="";	
		var checked_tasrif="";
		if (coran.colorize===1)      {checked_color="checked"}
		if (ArShaper.unicode06===1)  {checked_shape="checked"}
		if (coran.othmani===0)       {checked_rasm="checked"}
		if (almaredlib.includesarf===1)  {checked_tasrif="checked"}		
		   
		     
		var widget="<input type='image' alt='Submit' id='cssZoom1inB' src='img/minus.png' width='42' height='42'/></td><td><span id='cssZoom1'>"+almaredlib.getCurrentFontsize()+"</span>px</td><td><input type='image' alt='Submit' id='cssZoom1outB' src='img/plus.png' width='42' height='42'/>";
		//var widget=" : الحجم <button id='cssZoom1inB' class='rounded'>-</button><span id='cssZoom1'>"+almaredlib.getCurrentFontsize()+"</span>px<button id='cssZoom1outB' class='rounded'>+</button>";
		if (almaredlib.objectStyleSettings["current"]==="amiri") {checked_amiri="checked"; w_amiri=widget;}
		if (almaredlib.objectStyleSettings["current"]==="tahoma") {checked_tahoma="checked";w_tahoma=widget;}
		if (almaredlib.objectStyleSettings["current"]==="noto") {checked_noto="checked";w_noto=widget;}		
        var data_settings="<div id='settings' dir='"+almaredlib.dir+"' class='Table_A' style=\"font-family:"+almaredlib.getCurrentFonFamily()+";font-size:"+almaredlib.getCurrentFontsize()+"px\">";
		    if (almaredlib.app==="malki") {
				data_settings+="<input id='cssAddSarf' type='checkbox' name='settings' value='sarf'"+checked_tasrif +" >أضف مُصرّف الأفعال<br>";
			}
			var lang =almaredlib.objectStyleSettings["Lang"];
			data_settings+="<fieldset style='margin:10px'> <legend>"+almaredlib.translate[lang]["Tag1"]+"</legend>";
	        data_settings+="<input id='cssSettingsColorSarf1' type='radio' name='settings' value='coloron'"+almaredlib.checked(almaredlib.objectStyleSettings["colorSarf1"])+">"+almaredlib.translate[lang]["Tag2"]+": ﺃُﻫَﺠِّﺮَﻫُﻢْ "+"<br>";   
            data_settings+="<input id='cssSettingsColorSarf2' type='radio' name='settings' value='coloron'"+almaredlib.checked(almaredlib.objectStyleSettings["colorSarf2"])+">"+almaredlib.translate[lang]["Tag3"]+": <span style='color:black'>ﺃُ</span><span style='color:green'>ﻫَ</span><span style='color:blue'>ﺠِّ</span><span style='color:red'>ﺮَ</span><span style='color:#AD2323'>ﻫُﻢْ</span> <br>";
            data_settings+="<input id='cssSettingsColorSarf3' type='radio' name='settings' value='coloron'"+almaredlib.checked(almaredlib.objectStyleSettings["colorSarf3"])+">"+almaredlib.translate[lang]["Tag4"]+": <span style='color:black'>ﺃُ</span><span style='color:green'>ﻫ</span><span style='color:magenta'>َ</span><span style='color:blue'>ﺠ</span><span style='color:#DAA520'>ِّ</span><span style='color:red'>ﺮ</span><span style='color:#2F4F4F'>ُ</span><span style='color:#AD2323'>ﻫُﻢْ</span> <span style='color:black'>";     
			data_settings+="</fieldset>";
			
		    data_settings+="<fieldset style='margin:10px'> <legend>"+almaredlib.translate[lang]["Tag5"]+"</legend>";
			data_settings+="<table id='settingsTable'>";
            data_settings+="  <TR><TD><input  id='cssFontNoto' type=\"radio\" name=\"gender\" "+checked_noto+">    </TD><TD><span id='cssFontNotoS' style=\"font-family:NotoNaskhArabic\">"+almaredlib.translate[lang]["Tag6"]+"</span></TD><TD>"+w_noto+"</TD></TR>";			
            data_settings+="  <TR><TD><input  id='cssFontAmiri' type=\"radio\" name=\"gender\" "+checked_amiri+">  </TD><TD><span id='cssFontAmiriS' style=\"font-family:AmiriWeb\">"+almaredlib.translate[lang]["Tag7"]+"</span></TD><TD>"+w_amiri+"</TD></TR>";
            data_settings+="  <TR><TD><input  id='cssFontTahoma' type=\"radio\" name=\"gender\" "+checked_tahoma+"></TD><TD><span id='cssFontTahomaS' style=\"font-family:Tahoma, 'Times New Roman', sans-serif\">"+almaredlib.translate[lang]["Tag8"]+"</span></TD><TD>"+w_tahoma+"</TD></TR>";
            data_settings+="</table>";
			data_settings+="</fieldset>";
			
			 data_settings+="<fieldset style='margin:10px'> <legend>"+almaredlib.translate[lang]["Tag9"]+"</legend>";
			data_settings+="<input id='cssSettingsColor' type='checkbox' name='settings' value='coloron'"+checked_color +" >"+almaredlib.translate[lang]["Tag10"]+"<br>";
			data_settings+="<input id='cssSettingsCAlgo' type='checkbox' name='settings' value='coloralgo'"+checked_shape +">"+almaredlib.translate[lang]["Tag11"]+"<br>A-<span style='color: rgb(105, 222, 236);'>أَ</span><span style='color: rgb(92, 112, 133);'>فَ‍</span><span style='color: rgb(0, 191, 255);'>‍لَا&nbsp;</span><span style='color: rgb(28, 27, 29);'>يَتَدَبَّرُ</span><span style='color: rgb(255, 0, 0);'>ونَ&nbsp;</span><span style='color: rgb(0, 0, 255);'>الْ‍</span><span style='color: rgb(128, 128, 0);'>‍قُرْآنَ</span><br> B- <span style='color: rgb(105, 222, 236);'>ﺃَ</span><span style='color: rgb(92, 112, 133);'>ﻓَ</span><span style='color: rgb(0, 191, 255);'>ﻠَﺎ</span><span >&nbsp;</span><span style='color: rgb(28, 27, 29);'>ﻳَﺘَﺪَﺑَّﺮُ</span><span style='color: rgb(255, 0, 0);'>ﻭﻥَ</span><span >&nbsp;</span><span style='color: rgb(0, 0, 255);'>ﺍﻟْ</span><span style='color: rgb(128, 128, 0);'>ﻘُﺮْﺁﻥَ</span><br>";
			data_settings+="<input id='cssSettingsRasmType' type='checkbox' name='settings' value='rasmtype'"+checked_rasm +">"+almaredlib.translate[lang]["Tag12"];
	        data_settings+="</fieldset><br>";
	 
			data_settings+="<div align='center'><button  style='text-align:center;font-family:NotoNaskhArabic; font-size:16px;width:100px' id='exit_settings'>"+almaredlib.translate[lang]["Tag13"]+"</button></div><br>";
		document.getElementById("liveDisplayDivId").innerHTML=data_settings;	
}

almaredlib.setFontSize = function (newsize) {
	coran.contentFontSize=newsize;
	document.getElementById('settings').style.fontSize=newsize+'px';
	almaredlib.showSettings();
}

almaredlib.getCurrentFontsize = function () {
	return almaredlib.objectStyleSettings[almaredlib.objectStyleSettings["current"]]["font-size"];
}

almaredlib.setFontFamily = function (newfont) {
	coran.contentFontFamily=newfont;
	document.getElementById('settings').style.fontFamily= newfont;
	almaredlib.showSettings();
	almaredlib.initFontSetup();
}

almaredlib.getCurrentFonFamily = function () {
	return almaredlib.objectStyleSettings[almaredlib.objectStyleSettings["current"]]["font-family"];
}

almaredlib.initFontSetup = function () {
    coran.contentFontFamily=almaredlib.objectStyleSettings[almaredlib.objectStyleSettings["current"]]["font-family"];
	coran.contentFontSize=almaredlib.objectStyleSettings[almaredlib.objectStyleSettings["current"]]["font-size"];
}


document.querySelector('body').addEventListener('click', function(event) {
    if (event.target.id) {
         var node = document.getElementById(event.target.id);
         var ID = event.target.id;
        //console.log(ID);
	    if ( ID === "liveTasrifShareId") {
              almared_share(almaredlib.subjetshare[almaredlib.objectStyleSettings["Lang"]], document.getElementById('liveDisplayDivId').innerText);
	    }
		
		/*if ( ID == "navigation") {
               window.scrollTo(0,20);
	    }  */  
		if ( ID === "bsettings") {
			almaredlib.restoreProfileSettings();
			almaredlib.showSettings ();
	    }		 
		if ( ID === "cssFontTahoma") {
			var currentStyle="tahoma";
			almaredlib.objectStyleSettings["current"]=currentStyle;
			var currentFontFamily=almaredlib.objectStyleSettings[currentStyle]["font-family"];
			almaredlib.storeObject("objectStyleSettings",almaredlib.objectStyleSettings);
			almaredlib.setFontFamily(currentFontFamily);
	    }			 

		if ( ID === "cssFontAmiri") {
			var currentStyle="amiri";
			almaredlib.objectStyleSettings["current"]=currentStyle;
			var currentFontFamily=almaredlib.objectStyleSettings[currentStyle]["font-family"];
			almaredlib.storeObject("objectStyleSettings",almaredlib.objectStyleSettings);
			almaredlib.setFontFamily(currentFontFamily);
	    }	
		if ( ID === "cssFontNoto") {
			var currentStyle="noto";
			almaredlib.objectStyleSettings["current"]=currentStyle;
			var currentFontFamily=almaredlib.objectStyleSettings[currentStyle]["font-family"];
			almaredlib.storeObject("objectStyleSettings",almaredlib.objectStyleSettings);
			almaredlib.setFontFamily(currentFontFamily);
	    }			
		if ( ID === "exit_settings") {
             document.getElementById("settings").style.display='none';
	    }			 
		if ( ID === "cssZoom1outB") {
			  var currentStyle=almaredlib.objectStyleSettings["current"];
			  var currentSize=almaredlib.objectStyleSettings[currentStyle]['font-size'];
			  var newSize=parseInt(currentSize)+1;
			  almaredlib.objectStyleSettings[currentStyle]['font-size']=newSize;
			  almaredlib.storeObject("objectStyleSettings",almaredlib.objectStyleSettings);
			  document.getElementById("cssZoom1").innerText=newSize;
			  // Live update
			  almaredlib.setFontSize(newSize);
	    }	
		if ( ID === "cssZoom1inB") {
			  var currentStyle=almaredlib.objectStyleSettings["current"];
			  var currentSize=almaredlib.objectStyleSettings[currentStyle]['font-size'];
			  var newSize=parseInt(currentSize)-1;
			  almaredlib.objectStyleSettings[currentStyle]['font-size']=newSize;
			  almaredlib.storeObject("objectStyleSettings",almaredlib.objectStyleSettings);
			  document.getElementById("cssZoom1").innerText=newSize;
			  // Live update
			  almaredlib.setFontSize(newSize);
	    }	
        
    	if ( ID === "cssSettingsColorSarf1") {
			almaredlib.objectStyleSettings["colorSarf1"]=document.getElementById("cssSettingsColorSarf1").checked;
			almaredlib.objectStyleSettings["colorSarf2"]=document.getElementById("cssSettingsColorSarf2").checked;
			almaredlib.objectStyleSettings["colorSarf3"]=document.getElementById("cssSettingsColorSarf3").checked;			
            sarf.color=false;   
			almaredlib.storeObject("objectStyleSettings",almaredlib.objectStyleSettings);
	    }        
    	if ( ID === "cssSettingsColorSarf2") {
			almaredlib.objectStyleSettings["colorSarf1"]=document.getElementById("cssSettingsColorSarf1").checked;
			almaredlib.objectStyleSettings["colorSarf2"]=document.getElementById("cssSettingsColorSarf2").checked;
			almaredlib.objectStyleSettings["colorSarf3"]=document.getElementById("cssSettingsColorSarf3").checked;		
            sarf.color=true;  
            ArShaper.colorLevel=true;			
			almaredlib.storeObject("objectStyleSettings",almaredlib.objectStyleSettings);
	    }    
    	if ( ID === "cssSettingsColorSarf3") {
			almaredlib.objectStyleSettings["colorSarf1"]=document.getElementById("cssSettingsColorSarf1").checked;
			almaredlib.objectStyleSettings["colorSarf2"]=document.getElementById("cssSettingsColorSarf2").checked;
			almaredlib.objectStyleSettings["colorSarf3"]=document.getElementById("cssSettingsColorSarf3").checked;		
            sarf.color=true;  
            ArShaper.colorLevel=false;	   
			almaredlib.storeObject("objectStyleSettings",almaredlib.objectStyleSettings);
	    }    		
		
		if ( ID === "cssSettingsColor") {
			if (document.getElementById(ID).checked === true) {coran.colorize=1; almaredlib.storedb("checked_color","checked");} else {coran.colorize=0;almaredlib.storedb("checked_color","");}
	    }	
		if ( ID === "cssSettingsCAlgo") {
            if (document.getElementById(ID).checked === true) {ArShaper.unicode06=1; almaredlib.storedb("checked_shape","checked");} else {ArShaper.unicode06=0;almaredlib.storedb("checked_shape","");}
	    }	
		if ( ID === "cssSettingsRasmType") {
           if (document.getElementById(ID).checked === true) {coran.othmani=0;  almaredlib.storedb("checked_rasm","checked");} else {coran.othmani=1; almaredlib.storedb("checked_rasm","");}
	    }
		if ( ID === "cssAddSarf") {
           if (document.getElementById(ID).checked === true) {almaredlib.includesarf=1;  almaredlib.storedb("checked_tasrif","checked"); almaredlib.switchApplication ("nasr");} else {almaredlib.includesarf=0; almaredlib.storedb("checked_tasrif","");almaredlib.switchApplication ("malki");}
	    }		
		if ( ID === "bhelp") {
            document.getElementById('liveDisplayDivId').innerHTML=almaredlib.datahelp;
	    }
		if ( ID === "cssShareApplication") {
		   almared_share('المارد تصريف أفعال قرآن كريم','https://play.google.com/store/apps/details?id=com.almared.tarif');
		}
		if ( ID === "cssLikeApplication") {
		   window.open('https://play.google.com/store/apps/details?id=com.almared.tarif','_blank');
		}

	}
});

   
function almared_share(subject,datatext) {
	try {
        window.plugins.share.show( {subject: subject, text: datatext},
            function() {}, // Success function
            function() {alert('failed')} // Failure function
    );
	}
    catch(err) {
        console.log(err.message);
    }
};

function call_tasrif_full (form) {
    var jzr = getInputData();
	jzr=jzr.replace(/(\r\n|\n|\r| )/gm,"");
	jzr=jzr.replace(/\s/g, '');
	document.getElementById('liveDisplayDivId').innerHTML='';
	mizans=sarf.getMawazin(jzr); 
    data='';		
	for (i in mizans) {
		mz=mizans[i];
		sarf.tasrif(jzr,mz, parseInt(form),0);
        pack_sarf(mz);
	}	   						   								   
}

function unFireButtonByID (id) {
	document.getElementById(id).style.backgroundColor="#ffffff";
	document.getElementById(id).style['boxShadow']="inset 0px 0px 12px 0px #00000";
	document.getElementById(id).style.color="black";
}
function fireButtonByID (id) {
    document.getElementById(id).style.backgroundColor="green";
    document.getElementById(id).style['boxShadow']="inset 0px 0px 12px 0px #00FF0";
    document.getElementById(id).style.color="white";
}

function activeFullTasrif(v) {
    for (index=0;index<= 5;index++) {unFireButtonByID('SF'+index);}
    fireButtonByID(v);
    var mode = v.split('')[2];
    call_tasrif_full (mode);
}

function activeSingleTasrif(v) {
    almaredlib.sarf.type=v;
	for	(index = 0; index <= 6; index++) {unFireButtonByID('F'+index);}	
    fireButtonByID(v);
	call_tasrif ();
}

function activeMainChoice(v) {
    almaredlib.sarf.form=v; 
	
	document.getElementById("sarf.header").style.display = 'none';
	document.getElementById("cssSarfButtons").style.display = 'none';
	document.getElementById("cssAllSarfButtons").style.display = 'none';
	document.getElementById("sarf.header.mo").style.display='none';
    document.getElementById("cssCoranButtons").style.display = 'none';
    document.getElementById('sarf.header.aya').style.display='none';
	
    for	(index = 0; index <= 6; index++) {unFireButtonByID('F'+index);}
    
	unFireButtonByID('css.aya');
	unFireButtonByID('css.maaloom');
	unFireButtonByID('css.majhool');
	unFireButtonByID('css.allmode');
	fireButtonByID(v);

	if ( almaredlib.sarf.form == 'css.aya') {
		document.getElementById("css.title").innerText="المارد المالكي";
		document.getElementById("cssCoranButtons").style.display = '';
		document.getElementById('sarf.header.aya').style.display='';
        coran.serialSearch(); activeSingleSearch('AY0');
        return;
	} else {
		document.getElementById("css.title").innerText="المارد نصر العرب";
	}
    
    if ( almaredlib.sarf.form == 'css.allmode') {
		document.getElementById("cssAllSarfButtons").style.display = '';
		document.getElementById("sarf.header.mo").style.display = '';
	}	
	
    // T3:Maloom
	if ( almaredlib.sarf.form == 'css.maaloom') {
		document.getElementById("cssSarfButtons").style.display = '';
		document.getElementById("sarf.header").style.display = '';
	   	document.getElementById('F5').style.display = '';
	    document.getElementById('F6').style.display = '';
		if (almaredlib.sarf.type[0] != "F") {almaredlib.sarf.type = "F0";}
        
	} 
	// css.majhool Majhool 
	if ( almaredlib.sarf.form == 'css.majhool') {
	    document.getElementById("cssSarfButtons").style.display = '';
		document.getElementById("sarf.header").style.display = '';
	   	document.getElementById('F5').style.display = 'none';
	    document.getElementById('F6').style.display = 'none';	
		if (almaredlib.sarf.type[0] != "F") {almaredlib.sarf.type = "F0";}
	} 	
    
    if ( (almaredlib.sarf.type == "F5" ||  almaredlib.sarf.type == "F6") &&  almaredlib.sarf.form == "css.majhool") {
       almaredlib.sarf.type="F0";
    }
   
    fireButtonByID(almaredlib.sarf.type);
	call_tasrif ();
}

function pack_sarf (mz) {
    var res = "<br><table class='Table_A' style=\"font-family:"+almaredlib.getCurrentFonFamily()+";font-size:"+almaredlib.getCurrentFontsize()+"px\">";
    //B18904
	res+='<tr><TD colspan="15" bgColor="#BDB700"><center>التصريف وفقا للميزان رقم: '+(mz.toString()).toIndien()+'</center></TD>';
	res+='<tr><TH colspan="8"><center>المبني للمعلوم</center></TH> <TH></TH> <TH colspan=6><center>المبني للمجهول</center></TH></tr>';
	res+='<tr><TH></TH><TH>ماضي</TH><TH colspan="4"> مضارع</TH><TH colspan="2"><center>أمر</center></TH><TH></TH><TH></TH><TH>ماضي</TH><TH colspan="4"> مضارع</TH></tr>';
	res+='<TH>ضمير</TH>';
  	for (var jj=0;jj <=11;jj++) {
		if (jj==7) { res+='<TH></TH><TH></TH>';}
        res+='<TH>'+sarf.decode(sarf.header[jj])+'</TH>';
	}
    for (var i=0;i<=12;i++) {
	    
		if(i==2||i==7){res+='<tr><TD colspan="15" >';}
		res+='<TR>';
		res+='<TD bgcolor="#ECF6CE">'+sarf.decode(sarf.damir[i])+'</TD>'; 
	    
		for (var j=0;j<=11;j++) {
			   if (j==7) { res+='<TD></TD><TD bgcolor="#ECF6CE">'+sarf.decode(sarf.damir[i])+'</TD>';}
	           res+='<TD>'+sarf.data[i][j]+'</TD>';
        } 
		res+='</TR>';
	}
	res+='<tr><TH colspan="16" style="font-size: 12px; color: #237eb5;"><center><a title="Copyright © Al-Mared Engine '+sarf.engine+'" href="https://play.google.com/store/apps/details?id=com.almared.tarif">Copyright © Al-Mared Engine'+sarf.engine+'</a></center></TH></tr>';
    res+= '</table><br><br><br>';
    document.getElementById('liveDisplayDivId').innerHTML+= res;   
}
// // ******************************************************************************* 
// // *******************************************************************************

function tasrif (matrix) {
//var logEl = document.getElementById('liveDisplayDivId');
    var data = matrix.split('\n');
    var matrix = new Array();
    for (index in data) {
       ////console.log(data[index]);
	   matrix[index] = new Array();
	    row = data[index].split(";");
		for (jndex in row) {
		   matrix[index][jndex] = row[jndex];
		   ////console.log(row[jndex]);
		}
  }
  // F2 => 3  F4=> 5
  //console.log(almaredlib.sarf.type);
 if (almaredlib.sarf.form == 'css.maaloom') {
    colnum = parseInt ((almaredlib.sarf.type).split('')[1])+1;
 } else if (almaredlib.sarf.form == 'css.majhool') {
    colnum = parseInt ((almaredlib.sarf.type).split('')[1])+8;
 }
  cmpt = 0;
  res = "<table class='Table_A' style=\"font-family:"+almaredlib.getCurrentFonFamily()+";font-size:"+almaredlib.getCurrentFontsize()+"px\">";
  var t = new Array(14);
  for (j=0; j < 14 ; j++) {
    t[j] = '';
  }
  var thetype="";
  var cols=0;
  for (j=0; j < index ; j++) {
	    if (cmpt++ < 14) {
		    if (cmpt == 1)  { 
			    damir = matrix[j][0].split(',')[1];
			    t[j%14] += '<TH>' + damir + '</TH>'; 
			} else {
		        t[j%14] += '<TD>' + matrix[j][0] + '</TD>'; 
			}
		}
		if (j%14 == 0) {  
		   mizan = matrix[j][0].split(',')[0];
		    t[j%14] += '<TH><span class=\"numberCircle\">' + mizan.toIndien() + '</span></TH>';   
			thetype=matrix[j][colnum];
			if (colnum>=2 && colnum<=5 || colnum>=9) {thetype="المضارع ال"+matrix[j][colnum];}
			if (colnum==7) {thetype="الأمر ال" +matrix[j][colnum];}		
			cols++;
		} else {
		    t[j%14] += '<TD>' + matrix[j][colnum] + '</TD>'; 
		}
  }

  res+='<TR><TH><img id=\"liveTasrifShareId\" src=\"img/share2.png\" width=\"35\" height=\"35\"></TH><TH colspan=\"'+cols+'\">'+thetype+'</TH></TR>';
  for (j in t) {
		res += '<TR>' + t[j] + '</TR>';
  }   
  res += '</table>';
  //console.log(matrix);
 document.getElementById('liveDisplayDivId').innerHTML = res+'<br><span style=\"color:white\">' + 'ملاحظة: إذا كان تصريف الفعل الثلاثي كاملا يعني ٦ أوزان هذا معناه أنّ البرنامج لم يتعرّف على الفعل وتمّ تصريفه على جميع أوزان الثلاثي.' + '</span><br>'; 
}

function call_tasrif () {  
    var jzr = getInputData();
	var filtredjzr= jzr.replace(/\s/g, '');
	var x = jzr.split('');

	if (almaredlib.sarf.form == 'css.maaloom') {
	    //console.log("MALOOM");
		var mizans=sarf.getMawazin(filtredjzr); 
        data='';		
	    for (i in mizans) {
            data+=sarf.tasrif(filtredjzr,mizans[i],0,1);

	    }	   
	    tasrif(data); 
	} else if (almaredlib.sarf.form == 'css.majhool') {
	    //console.log("MAJHOOL"); 
		var mizans=sarf.getMawazin(filtredjzr); 
        data='';		
	    for (i in mizans) {
         data+=sarf.tasrif(filtredjzr,mizans[i],0,1); 
	    }	
        tasrif(data); 

	} else if  (almaredlib.sarf.form == 'css.aya') {
        //coran.resetsearch();
		//coran.searchHtml("liveDisplayDivId",getInputData());
        coran.serialSearch(); activeSingleSearch(this.id);
        
    } else {
	    document.getElementById('liveDisplayDivId').innerText = '';
	}
}

String.prototype.toIndien = function () { // PERSIAN, ARABIC, URDO
    var newValue="";
    for (var i=0;i<this.length;i++)
    {
        var ch=this.charCodeAt(i);
        if (ch>=48 && ch<=57)
        {
            // european digit range
            var newChar=ch+1584;
            newValue=newValue+String.fromCharCode(newChar);
        }
        else
            newValue=newValue+String.fromCharCode(ch);
    }
    return newValue;
}

function activeSingleSearch (v) {
    almaredlib.sarf.type=v;
	for	(index = 0; index <= 2; index++) {unFireButtonByID('AY'+index);}	
    fireButtonByID(v);
    coran.resetsearch();
	coran.searchHtml("liveDisplayDivId",getInputData());	
}

function activeButtons (v) {
    for	(index = 0; index <= 2; index++) {unFireButtonByID('AY'+index);}	
    fireButtonByID(v);	
}
// ----- TO UNICODE 06, some mobile transform unicode 0x06 to 0xFX
// this function will retransform the input to the right values  -------
var unicode06={}; 
unicode06.map = {
0xFE80:[0x0621],0xFB51:[0x0671], 0xFB50:[0x0671],
0xFE81:[0x0622],0xFE82:[0x0622], 
0xFE83:[0x0623],0xFE84:[0x0623], 
0xFE85:[0x0624],0xFE86:[0x0624], 
0xFE87:[0x0625],0xFE88:[0x0625], 
0xFE89:[0x0626],0xFE8B:[0x0626], 0xFE8C:[0x0626], 0xFE8A:[0x0626], 
0xFE8D:[0x0627],0xFE8E:[0x0627], 
0xFE8F:[0x0628],0xFE91:[0x0628], 0xFE92:[0x0628], 0xFE90:[0x0628], 
0xFE93:[0x0629],0xFE94:[0x0629], 
0xFE95:[0x062A],0xFE97:[0x062A], 0xFE98:[0x062A], 0xFE96:[0x062A], 
0xFE99:[0x062B],0xFE9B:[0x062B], 0xFE9C:[0x062B], 0xFE9A:[0x062B], 
0xFE9D:[0x062C],0xFE9F:[0x062C], 0xFEA0:[0x062C], 0xFE9E:[0x062C], 
0xFEA1:[0x062D],0xFEA3:[0x062D], 0xFEA4:[0x062D], 0xFEA2:[0x062D], 
0xFEA5:[0x062E],0xFEA7:[0x062E], 0xFEA8:[0x062E], 0xFEA6:[0x062E], 
0xFEA9:[0x062F],0xFEAA:[0x062F], 
0xFEAB:[0x0630],0xFEAC:[0x0630], 
0xFEAD:[0x0631],0xFEAE:[0x0631], 
0xFEAF:[0x0632],0xFEB0:[0x0632], 
0xFEB1:[0x0633],0xFEB3:[0x0633], 0xFEB4:[0x0633], 0xFEB2:[0x0633], 
0xFEB5:[0x0634],0xFEB7:[0x0634], 0xFEB8:[0x0634], 0xFEB6:[0x0634], 
0xFEB9:[0x0635],0xFEBB:[0x0635], 0xFEBC:[0x0635], 0xFEBA:[0x0635], 
0xFEBD:[0x0636],0xFEBF:[0x0636], 0xFEC0:[0x0636], 0xFEBE:[0x0636], 
0xFEC1:[0x0637],0xFEC3:[0x0637], 0xFEC4:[0x0637], 0xFEC2:[0x0637], 
0xFEC5:[0x0638],0xFEC7:[0x0638], 0xFEC8:[0x0638], 0xFEC6:[0x0638], 
0xFEC9:[0x0639],0xFECB:[0x0639], 0xFECC:[0x0639], 0xFECA:[0x0639], 
0xFECD:[0x063A],0xFECF:[0x063A], 0xFED0:[0x063A], 0xFECE:[0x063A], 
0x0640:[0x0640],0x0640:[0x0640], 0x0640:[0x0640], 0x0640:[0x0640], 
0xFED1:[0x0641],0xFED3:[0x0641], 0xFED4:[0x0641], 0xFED2:[0x0641], 
0xFED5:[0x0642],0xFED7:[0x0642], 0xFED8:[0x0642], 0xFED6:[0x0642], 
0xFED9:[0x0643],0xFEDB:[0x0643], 0xFEDC:[0x0643], 0xFEDA:[0x0643], 
0xFEDD:[0x0644],0xFEDF:[0x0644], 0xFEE0:[0x0644], 0xFEDE:[0x0644], 
0xFEE1:[0x0645],0xFEE3:[0x0645], 0xFEE4:[0x0645], 0xFEE2:[0x0645], 
0xFEE5:[0x0646],0xFEE7:[0x0646], 0xFEE8:[0x0646], 0xFEE6:[0x0646], 
0xFEE9:[0x0647],0xFEEB:[0x0647], 0xFEEC:[0x0647], 0xFEEA:[0x0647], 
0xFEED:[0x0648],0xFEEE:[0x0648], 
0xFEEF:[0x0649],0xFEF0:[0x0649], 
0xFEF1:[0x064A],0xFEF3:[0x064A], 
0xFEF4:[0x064A],0xFEF2:[0x064A], 
0xFEF5:[0x0644,0x0627,0x0653], 
0xFEF6:[0x0644,0x0627,0x0653],
0xFEF7:[0x0644,0x0623] , 0xFEF8:[0x0644,0x0623],
0xFEF9:[0x0644,0x0625] , 0xFEFA:[0x0644,0x0625],
0xFEFB:[0x0644,0x0627] , 0xFEFC:[0x0644,0x0627],
0x002C:[0x060C],
0xfdf2:[0x0627,0x0644,0x0644,0x0647]}
	
String.prototype.utffizearabic = function () {
    var data="";
	var code = 0;
    for (var i=0; i < this.length ; i++) {
		code = this[i].charCodeAt();
		
        if (unicode06.map[code] != undefined) {
			for (var x in unicode06.map[code]) {
				data+= String.fromCharCode(unicode06.map[code][x]);
			}
		}  else {
		    data+=this[i];
		}
	}
    data=data.replace(/&nbsp;/g,' ');    
    return data;	
};

// ----- END TO UNICODE 06 -------
function getInputData () {
	var str=document.getElementById('searchDivInputId').value;
	return str.utffizearabic()
}


// almaredlib.changefont = function (newfont) {
//     var elements = document.getElementsByClassName('Table_A');
//     for (var i = 0; i < elements.length; i++) {
//         var element = elements[i];
//         //element.style.fontSize = "2em";
// 		element.style.fontFamily = newfont;
//     }
// }
// almaredlib.changefont = function (newsize) {
//     var elements = document.getElementsByClassName('Table_A');
//     for (var i = 0; i < elements.length; i++) {
//         var element = elements[i];
//         element.style.fontSize = newsize+'px';
//     }
// }




// should be loaded at the end of all files
// almaredlib.switchApplication ("malki");
almaredlib.restoreProfileSettings();
almaredlib.switchApplication ("nasr");
document.getElementById('liveDisplayDivId').innerHTML=almaredlib.datahelp;


// skoun \u030A
// kasra \u0316
// fatha \u0340
// an  \u030E
// in   \u030A
// c   \u032B 
// mad  \u0342
// damma \u0313



almaredlib.setlang (almaredlib.objectStyleSettings["Lang"]);
